#include "csrpg2.h"
#include <fstream>
using namespace std;

class CreditLine {
public:
	bool bIsBlankLine;
	string str;
	float screen_y;
	CreditLine() {
		bIsBlankLine = false;
		screen_y = 100000;
	}
};

void CGame::ScrollyText(char *file) {
	vector <CreditLine*> lineVec;
	// Load credits into a vector.
	ifstream TheFile(file);
	if(!TheFile) {
		fprintf(stderr,"%s is missing\n",file);
		return;
	}
	int i = 0;
	bool bDoneLoading = false;
	printf("Loading comments\n");
	while(!bDoneLoading) {
		if(TheFile.eof() || i > 125) {
			// Only 125 lines maximum
			bDoneLoading = true;
		}
		i++;
		char *str = new char[125];
		CreditLine *line = new CreditLine();
		TheFile.getline(str,125);
		if(strlen(str) < 1) {
			// Blank line
			line->bIsBlankLine = true;
		} else {
			line->str = str;
		}
		line->screen_y = 550 + (returnTextHeight() * i);
		lineVec.push_back(line);
		delete[] str;
	}
	printf("Comments loaded. Engaging.\n");
	// OK, great. Let's go!
	bool bDone = false;
	SDL_Rect upperBar;
	SDL_Rect lowerBar;
	upperBar.x = 0;
	upperBar.y = 0;
	upperBar.w = SCREEN_WIDTH;
	upperBar.h = 70;
	lowerBar.x = 0;
	lowerBar.y = 530;
	lowerBar.w = SCREEN_WIDTH;
	lowerBar.h = 70;
	
	while(!bDone) {
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
		vars.timer_start = SDL_GetTicks();
		// update the lines
		for(Uint32 i = 0; i < lineVec.size(); i++) {
			// Update line position
			if(lineVec[i]->screen_y > 50) {
				lineVec[i]->screen_y -= 50*vars.timer_delta;
			}
			// Draw the lines
			if(lineVec[i]->screen_y > 50 && lineVec[i]->screen_y < 540) {
				if(lineVec[i]->bIsBlankLine) {
					drawTextAt(" ",100,(int)(lineVec[i]->screen_y));
				}
				else {
					drawTextAt(lineVec[i]->str.c_str(),100,(int)(lineVec[i]->screen_y));
				}
			}
		}
		// Draw "Widescreen" bars.
		SDL_FillRect(screen,&upperBar,SDL_MapRGB(screen->format,0,0,0));
		SDL_FillRect(screen,&lowerBar,SDL_MapRGB(screen->format,0,0,0));
		drawTextAt("Press any key to continue...",10,600 - returnTextHeight());
		// figure out how to end
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_QUIT || event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_F3) {
					SDL_SaveBMP(screen,"sshot.bmp");
				}
				bDone = true;
			}
		}
		SDL_Flip(screen);
		SDL_Delay(0);
		vars.timer_elapsed = SDL_GetTicks() - vars.timer_start;
		vars.timer_delta = vars.timer_elapsed/1000.0f;
	}
	vars.timer_elapsed = 0;
	vars.timer_delta = 0;
	vars.timer_start = SDL_GetTicks();
	lineVec.clear();
}