#include "csrpg2.h"

void CGame::raiseError(char *err) {
	/*
		OS- and API-independent function that can be abstracted to display
			- MessageBoxes under WinNT
			- Dialogue boxes under OS9
			- System warnings under Linux
			- Other OS-dependent warnings.
			- A potential future use would be to extend the game's "talking system"
			  to display in-engine failures in red.
	*/
	fprintf(stderr,err);
}

void CGame::errorDialogue(char *str) {
	SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,100));
	centreTextAt(str, 300-(returnTextHeight()/2));
	centreTextAt("Press any key to continue..", 600-returnTextHeight());
	SDL_Flip(screen);
	bool bDone = false;
	while(!bDone) {
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_KEYDOWN || event.type == SDL_QUIT) {
				return;
			}
		}
		SDL_Delay(0);
	}
}