#include "csrpg2.h"
#include "fEffect.h"

void CGame::fightEffectAt(float x, float y, int icon, char *txt) {
	// Render a fight effect based on world coordinates, so scrolling works ok
	int dx = ((SCREEN_WIDTH/2)-48) - (int)(player->x - x);
	int dy = 252 - (int)(player->y - y);
	fightEffect *newEffect = new fightEffect();
	newEffect->x = dx;
	newEffect->y = dy;
	newEffect->icon = icon;
	newEffect->text = txt;
	fvars.effects.push_back(newEffect);
}

void CGame::drawFightEffects() {
	/*
		Go through and find the responsible fight effects from the bunch, and then draw them all
		with their associated text.
	*/
	list <fightEffect*>::iterator fit;
	for(fit = fvars.effects.begin(); fit != fvars.effects.end(); fit++) {
		fightEffect *te = *fit;
		te->timer -= vars.timer_elapsed;
		if(te->timer > 0) {
			// Draw the icon
			SDL_Rect rect = {0,0,0,0};
			rect.w = 48;
			rect.h = 48;
			rect.x = (int)te->x;
			rect.y = (int)te->y;
			SDL_BlitSurface(art.icons[te->icon],NULL,screen,&rect);
			// Draw the text, nicely now.
			drawTextAt(te->text.c_str(),(int)(te->x + 20),(int)(te->y + ((48 - returnTextHeight())/2)));
			// Make it float up
			te->y -= 10 * vars.timer_delta;
		} else {
			fvars.effects.remove(te);
			delete te;
			return;
		}
	}
}

void CGame::effectAlongLine(float px, float py, float xt, float yt, int effect) {
	int tx1, ty1, tx2, ty2;
	tx1 = (int)(px/48);
	tx2 = (int)(xt/48);
	ty1 = (int)(py/48);
	ty2 = (int)(yt/48);
	bool bDone = false;
	int x, y;
	x = tx1;
	y = ty1;
	int reps = 0;
	while(!bDone) {
		reps++;
		if(!(x == tx1 && y == tx1)) {
			if(effect == 1) {
				fightEffectAt(x * 48, y * 48, ICON_FIREBALL, " ");
			}
		}
		if(x < tx2) {
			x++;
		}
		else if(x > tx2) {
			x--;
		}
		if(y < ty2) {
			y++;
		}
		else if(y > ty2) {
			y--;
		}
		if((x == tx2 && y == ty2) || (reps > 10) || (theMap->isSolid(x,y))) {
			bDone = true;
		}
	}
}