#include "csrpg2.h"

void CGame::getFightInput() {
	while(SDL_PollEvent(&event)) {
		if(event.type == SDL_QUIT) {
			exit(0);
		} 
		else if(event.type == SDL_KEYDOWN) {
			if(event.key.keysym.sym == SDLK_F3) {
				SDL_SaveBMP(screen,"sshot.bmp");
			}
			else if(event.key.keysym.sym == SDLK_UP) {
				if(!theMap->isSolid(player->x,player->y - 48)) {
					if(!combatCollide(player,enemy,0,-48)) {
						vars.bYourTurn = false;
						player->y -= 48;
						player->direction = 0;
					}
				}
			}
			else if(event.key.keysym.sym == SDLK_DOWN) {
				if(!theMap->isSolid(player->x,player->y + 48)) {
					if(!combatCollide(player,enemy,0,48)) {
						player->y += 48;
						vars.bYourTurn = false;
						player->direction = 2;
					}
				}
			}
			else if(event.key.keysym.sym == SDLK_LEFT) {
				if(!theMap->isSolid(player->x - 48, player->y)) {
					if(!combatCollide(player,enemy,-48,0)) {
						vars.bYourTurn = false;
						player->x -= 48;
						player->direction = 3;
					}
				}
			}
			else if(event.key.keysym.sym == SDLK_RIGHT) {
				if(!theMap->isSolid(player->x + 48, player->y)) {
					if(!combatCollide(player,enemy,48,0)) {
						vars.bYourTurn = false;
						player->x += 48;
						player->direction = 1;
					}
				}
			}
			if(event.key.keysym.sym == SDLK_b) {
				if(!fvars.bMenuOpen) {
					// Next weapon
					if(fvars.selectedWeapon > 0) {
						fvars.selectedWeapon--;
						string result = "Switched weapons.";
						vars.fightMsgVec.push_back(result);
					}
				} else {
					// Flee spell
					if(player->stats.mp < 15) {
						string str = "Not enough mana to cast flee, need 15";
						vars.fightMsgVec.push_back(str);
					} else {
						playSound(7);
						player->stats.mp -= 15;
						if(rand() % 8 > 6) {
							// wheeeeeeeee.
							bPlayingGame = true;
							player->x = 48;
							player->y = 48; // Send them to (1,1)
						} else {
							string str = "Failure. Could not escape!";
							vars.fightMsgVec.push_back(str);
						}
					}
				}
			}
			else if(event.key.keysym.sym == SDLK_v) {
				if(!fvars.bMenuOpen) {
					// Previous weapon
					if(fvars.selectedWeapon < (int)(fvars.weapons.size()-1)) {
						fvars.selectedWeapon++;
						string result = "Switched weapons.";
						vars.fightMsgVec.push_back(result);
					}
				} else {
					// Pain spell -- causes massive damage through walls but can miss
					if((int)(distance(player->x,player->y,enemy->x,enemy->y)/48) < 4) {
						if(player->stats.mp >= 15) {
							playSound(6);
							player->stats.mp -= 15;
							vars.bYourTurn = false;
							if(rand() % 6 >= 4) {
								// Hit
								int dmg = (rand() % 30) + player->stats.intelligence;
								char *s_dmg = new char[40];
								sprintf(s_dmg,"%i",dmg);
								enemy->stats.hp -= dmg;
								fightEffectAt(enemy->x,enemy->y,ICON_HIT,s_dmg);
								delete[] s_dmg;
								char *result = new char[60];
								sprintf(result,"Radiated pain for %i damage!",dmg);
								string results = result;
								vars.fightMsgVec.push_back(results);
								delete[] result;
							}
							else {
								// Miss'd
								fightEffectAt(enemy->x,enemy->y,ICON_MISSED,"Miss");
								string result = "Missed!";
								vars.fightMsgVec.push_back(result);
							}
						}
						else {
							string result = "Not enough MP to cast Pain, need 15";
							vars.fightMsgVec.push_back(result);
						}
					}
					else {
						string result = "Too far away to cast Pain";
						vars.fightMsgVec.push_back(result);
					}
				}
			}
			else if(event.key.keysym.sym == SDLK_z) {
				if(!fvars.bMenuOpen) {
					// Attack
					if(fvars.weapons.size() < 1 || fvars.weapons[fvars.selectedWeapon]->type != ITEM_BOW) {
						if((int)(distance(player->x,player->y,enemy->x,enemy->y)/48) < 2) {
							// Within range. Beat him down
							int maxDmg = 1;
							string result = "Attacking with fists";
							if(fvars.weapons.size() > 0) {
								maxDmg = (int)(fvars.weapons[fvars.selectedWeapon]->maxEffect * (vars.drunkenness+1));
								result = "Attacking with " + fvars.weapons[fvars.selectedWeapon]->itemName;
							}
							vars.fightMsgVec.push_back(result);
							char *outcome = new char[200];
							// OK, take a roll and plus it with your str
							int attackRoll = (rand() % maxDmg) + player->stats.strength;
							int defenseRoll = (rand() % enemy->stats.dexterity);
							if(attackRoll < defenseRoll) {
								sprintf(outcome,"Missed!");
								fightEffectAt(enemy->x, enemy->y, ICON_MISSED, "Miss");
							} else {
								attackRoll -= defenseRoll;
								enemy->stats.hp -= attackRoll;
								if(fvars.weapons.size() < 1) {
									// Attacking with fist
									playSound(1);
								}
								else {
									// Attacking with blade
									
								}
								sprintf(outcome,"Hit for %i damage",attackRoll);
								char *num = new char[50];
								sprintf(num,"%i",attackRoll);
								fightEffectAt(enemy->x, enemy->y, ICON_HIT, num);
								delete[] num;
							}
							string s_outcome = outcome;
							vars.fightMsgVec.push_back(s_outcome);
							delete[] outcome;
							//SDL_Delay(200);
							vars.bYourTurn = false;
						}
					}
					else {
						// Long-range attack!
						// Use maxEffect as damage
						fvars.bIsStillShooting = true;
						Item* weap = fvars.weapons[fvars.selectedWeapon];
						if((int)(distance(player->x,player->y,enemy->x,enemy->y)/48) < weap->range) {
							playSound(3);
							if(enemy->canSee(player->x,player->y,theMap)) {
								// Bang, I hit them
								int maxDmg = (int)weap->maxEffect;
								int attackRoll = (rand() % maxDmg) + player->stats.strength;
								int defenseRoll = (rand() % enemy->stats.dexterity);
								char *str = new char[200];
								attackRoll -= defenseRoll;
								if(attackRoll < 0) {
									attackRoll = 0;
								}
								if(attackRoll < defenseRoll) {
									sprintf(str,"Missed!");
									fightEffectAt(enemy->x,enemy->y,ICON_MISSED,"Miss");
								} else {
									if(rand() % 20 == 1) {
										sprintf(str,"CRITICAL HIT! Hit for %i damage", attackRoll*2);
										enemy->stats.hp -= attackRoll * 2;
										char *num = new char[40];
										sprintf(num, "%i", attackRoll*2);
										fightEffectAt(enemy->x, enemy->y, ICON_CRITICALHIT, num);
										delete[] num;
									} else {
										sprintf(str,"Hit for %i damage",attackRoll);
										enemy->stats.hp -= attackRoll;
										char *num = new char[40];
										sprintf(num,"%i",attackRoll);
										fightEffectAt(enemy->x,enemy->y,ICON_HIT,num);
										delete[] num;
									}
								}
								string result = str;
								delete[] str;
								vars.fightMsgVec.push_back(result);
								fvars.bIsStillShooting = true;
								fvars.shot_x = player->x + 24;
								fvars.shot_y = player->y + 24;
							}
							else {
								string result = "Missed shot, obstacle in the way!";
								fvars.bIsStillShooting = true;
								fvars.shot_x = player->x + 24;
								fvars.shot_y = player->y + 24;
								vars.fightMsgVec.push_back(result);
							}
							vars.bYourTurn = false;
						} else {
							char *res = new char[80];
							sprintf(res,"Too far away, max range of this weapon is %i",weap->range);
							string outcome = res;
							vars.fightMsgVec.push_back(res);
							delete[] res;
						}
					}
				} else {
					// Fire ball spell
					if(player->stats.mp >= 5) {
						player->stats.mp -= 5;
						vars.bYourTurn = false;
						effectAlongLine(player->x,player->y,enemy->x,enemy->y,1); // Draw fireballs
						fvars.movetimer = 1000.0f;
						if((int)(distance(player->x,player->y,enemy->x,enemy->y)/48) < 6) {
							playSound(10);
							if(enemy->canSee(player->x,player->y,theMap)) {
								// OK, we hit them
								int damage = (rand() % 10) + player->stats.intelligence;
								char *num = new char[50];
								sprintf(num,"Hit for %i damage",damage);
								string str = num;
								enemy->stats.hp -= damage;
								char *num2 = new char[30];
								sprintf(num2,"%i",damage);
								fightEffectAt(enemy->x, enemy->y, ICON_HIT, num2);
								vars.fightMsgVec.push_back(str);
								delete[] num;
								delete[] num2;
								playSound(1);
							} else {
								string str = "Couldn't hit enemy, wall in the way";
								vars.fightMsgVec.push_back(str);
								vars.bYourTurn = false;
							}
						} else {
							string str = "Couldn't hit enemy, too far away";
							vars.fightMsgVec.push_back(str);
						}
					} else {
						string str = "Not enough mana to cast fireball (need 5)";
						vars.fightMsgVec.push_back(str);
					}
				}
			}
			else if(event.key.keysym.sym == SDLK_x) {
				if(!fvars.bMenuOpen) {
					// Open item menu, pick combat-usable item
					inventoryMenu();
					vars.bYourTurn = false;
				}
				else {
					// Heal spell
					if(player->stats.mp >= 10) {
						playSound(11);
						player->stats.mp -= 10;
						int healing = (rand() % 10) + player->stats.intelligence;
						player->stats.hp += healing;
						if(player->stats.hp > (int)player->stats.hp_max) {
							player->stats.hp = player->stats.hp_max;
						}
						// Draw the effect
						char *num = new char[50];
						char *num2 = new char[30];
						sprintf(num2,"%i",healing);
						fightEffectAt(player->x,player->y,ICON_HEALFX,num2);
						// Install the result
						sprintf(num,"Healed %i health",healing);
						string str = num;
						vars.fightMsgVec.push_back(str);
						delete[] num;
						delete[] num2;
						// Bang the turn clock
						vars.bYourTurn = false;
					}
					else {
						string str = "Not enough mana to cast heal (need 10)";
						vars.fightMsgVec.push_back(str);
					}
				}
			}
			else if(event.key.keysym.sym == SDLK_SPACE) {
				string result = "Waited...";
				vars.fightMsgVec.push_back(result);
				vars.bYourTurn = false;
			}
			else if(event.key.keysym.sym == SDLK_c) {
				// Flip between magic and "mundane" menu
				fvars.bMenuOpen = !fvars.bMenuOpen;
			}
		}
	}
	if(!vars.bYourTurn) {
		// You moved this turn.
		string result = "Enemy's move.";
		vars.fightMsgVec.push_back(result);
	}
}