#include "fightvars.h"
#include "csrpg2.h"

/*
	This file provides initialization and reset facilities for the fight variables, so as
	to set the game engine up properly for an incoming fight.
*/

FightVars::FightVars() {
	selectedWeapon = 0;
	menuSelection = 0;
	movetimer = 0;
	bMenuOpen = false;
	bIsStillShooting = 0;
	shot_x = 0;
	shot_y = 0;
	scroll = 0;
}

void CGame::cleanUpFightVars() {
	list <fightEffect*>::iterator it;
	while(fvars.effects.size() > 0) {
		// Clear out the list of fight effects
		it = fvars.effects.end();
		it--;
		fightEffect* te = *it;
		fvars.effects.remove(te);
		delete te;
	}
	fvars.selectedWeapon = 0;
	fvars.menuSelection = 0;
	fvars.movetimer = 0;
	fvars.bMenuOpen = false;
	fvars.bIsStillShooting = false;
	fvars.shot_x = 0;
	fvars.shot_y = 0;
	fvars.scroll = 0;
}