#include "csrpg2.h"
#include "vars.h"
#include <fstream>

CGame::CGame() {
	bool bSetScreen = false;
	// FIXME: Must initialize SDL first!!!
	if(SDL_Init(SDL_INIT_EVERYTHING) < 0) {
		fprintf(stderr,"SDL failed init: %s\n",SDL_GetError());
		exit(1);
	}
	std::ifstream configFile("config.cfg");
	TALK_TIMER = 1700.0f;
	SCREEN_WIDTH = 800;
	if(configFile) {
		printf("Reading from config.cfg....\n");
		while(!configFile.eof()) {
			string line;
			char *temp = new char[100];
			configFile.getline(temp,98);
			line = temp;
			
			// Now tokenize the line
			if(line == "fs" || line == "fullscreen") {
				// Fullscreen mode!!!
				printf("\tEnabled fullscreen\n");
				screen = SDL_SetVideoMode(SCREEN_WIDTH,600,32,SDL_HWSURFACE|SDL_DOUBLEBUF|SDL_FULLSCREEN);
				bSetScreen = true;
			}
			else if(line == "picksaplenty") {
				printf("\tCheating fucker, you enabled invincible lockpick mode!\n");
				vars.bCheatPick = true;
			}
			else if(line == "noalpha") {
				printf("\tDisabled Alpha\n");
				vars.bNoAlpha = true;
			}
			else if(line == "widescreen") {
				printf("\tEnabled widescreen! Windowing..\n");
				SCREEN_WIDTH = 1024;
				screen = SDL_SetVideoMode(SCREEN_WIDTH,600,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
				bSetScreen = true;
			}
			else if(line == "longtalk") {
				TALK_TIMER = 2500.0f;
				printf("\tTalk timer slowed\n");
			}
			else if(line == "windowed") {
				printf("\tWindowed mode enabled\n");
				if(SCREEN_WIDTH != 1024) {
					bSetScreen = false;
				}
			}
			else if(line == "fastwater") {
				printf("\tFast water enabled\n");
				vars.bFastWater = true;
			}
			else if(line == "debug") {
				printf("\tHello developers\n");
				vars.debugMode = true;
			}
			delete[] temp;
		}
	}
	if(!bSetScreen) {
		screen = SDL_SetVideoMode(SCREEN_WIDTH,600,32,SDL_HWSURFACE|SDL_DOUBLEBUF);
	}
	TTF_Init();
	font = TTF_OpenFont("data/assets/font.ttf",14);
	art.loadAssets();
	if(art.icons[27]) {
		SDL_SetColorKey(art.icons[27], SDL_SRCCOLORKEY, 
						SDL_MapRGB(art.icons[27]->format, 255, 0, 255)); 
		SDL_WM_SetIcon(art.icons[27], NULL);
	}
	bMustQuit = 0;
	mode = 0;
	bPlayingGame = 0;
	bPleaseLoadGame = 0;
	vars.gameName = "Firetruck Rocketship University";
	vars.dir = "data";
	SDL_WM_SetCaption("CSRPG 2.0",NULL);
	atexit(SDL_Quit);
	theMap = new Map();
	theMap->Init();
	textHeight = 0;
	wipeEntities();
	if(SDL_NumJoysticks() > 0) {
		printf("Joystick(s) detected and activated\n");
		SDL_JoystickEventState(SDL_ENABLE);
		joystick = SDL_JoystickOpen(0);
	}
}

void CGame::wipeEntities() {
	list <Actor*>::iterator ait;
	while(actorList.size() > 0) {
		// Unload actors
		for(ait = actorList.begin(); ait != actorList.end(); ait++) {
			Actor *te = *ait;
			actorList.remove(te);
			delete te;
			ait = actorList.end();
		}
	}
	list <Quest*>::iterator qit;
	while(questList.size() > 0) {
		// Unload actors
		for(qit = questList.begin(); qit != questList.end(); qit++) {
			Quest *te = *qit;
			questList.remove(te);
			delete te;
			qit = questList.end();
		}
	}
}

CGame::~CGame() {
	TTF_Quit();
	art.unloadAssets();
}