#include "csrpg2.h"

void CGame::gameLoop() {
	int frames = 0;
	float lastFPScheck = 0;
	bPlayingGame = true;
	bMustQuit = false;
	//Uint16 frames = 0;
	while(!bMustQuit) {
		if(player->stats.hp < 1 || !player) {
			// Uh oh... you died!
			deathScreen();
		}
		else if(player->stats.hp > player->stats.hp_max) {
			// Make sure our idiot user didn't cheat
			player->stats.hp = player->stats.hp_max;
		}
		vars.frames++;
		vars.timer_start = SDL_GetTicks();
		//printf("Looped\n");
		if(bPlayingGame) {
			drawMap();
			drawSprites();
			drawHud();
			getInput();
			AIManager();
		}
		else {
			// determine what 'other' game mode they're on
			if(mode == 1) {
				if(!enemy) {
					fprintf(stderr,"Enemy doesn't exist! WTF\n");
				}
				// Fighting!!!
				drawMap();
				drawSprites();
				drawFightHUD();
				if(vars.bYourTurn) {
					fvars.bIsStillShooting = false;
					getFightInput();
				} else {
					if(fvars.movetimer > 0 || fvars.bIsStillShooting) {
						// Pause for a while to admire the fireball
						drawMap();
						drawSprites();
						drawFightHUD();
						updateBullet();
						pollScreenshot();
						if(fvars.bIsStillShooting == false) {
							fvars.movetimer -= vars.timer_elapsed;
						}
					} else {
						fightAI(enemy,player);
						vars.bYourTurn = true;
						string yourTurn = "Your turn.";
						vars.fightMsgVec.push_back(yourTurn);
					}
				}
				// Get player input
				// Move the enemy
				if(distance(enemy->x, enemy->y, player->x, player->y) > 500) {
					// Let the player escape, maybe if the enemy is "stuck"
					vars.currentTalk = "You ran away";
					vars.talkTimer = TALK_TIMER;
					cleanUpFightVars();
					mode = 0;
					bPlayingGame = true;
					vars.fightMsgVec.clear();
				}
				if(enemy->stats.hp < 1) {
					// Draw the FX so the players aren't wondering what happened to their pretty graphics.
					drawFightHUD();
					// Midpoint it to look good
					fvars.shot_x = ((player->x+24)+(enemy->x+24))/2;
					fvars.shot_y = ((player->y+24)+(enemy->y+24))/2;
					updateBullet();
					// VICTORY SCREEN!!!
					// Congratulations. You killed the stupid bastard.
					cleanUpFightVars();
					bPlayingGame = true;
					mode = 0;
					actorList.remove(enemy);
					delete enemy;
					// Clean up the vector, please.
					vars.fightMsgVec.clear(); // Maybe bug
					player->stats.xp++;
					bool bLevelledUp = false;
					player->stats.money += 50;
					if(player->stats.xp >= 4) {
						player->stats.xp -= 4;
						player->stats.level++;
						bLevelledUp = true;
					}
					bool bDone = false;
					playSound(0);
					while(!bDone) {
						//SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
						drawTextAt("You won the fight! Got 50 gold",10,300);
						if(bLevelledUp) {
							drawTextAt("Level up!",10,300 + returnTextHeight());
							drawTextAt("Pick a reward:",10, 300 + returnTextHeight() * 2);
							drawTextAt("(S)trength up",10, 300 + returnTextHeight()*3);
							drawTextAt("(D)exterity up",10,300+returnTextHeight()*4);
							drawTextAt("(I)ntelligence up",10,300+returnTextHeight()*5);
							drawTextAt("(F)abulous Cash Prize",10,300+returnTextHeight()*6);
						} else {
							drawTextAt("Press return to continue...",10,300+returnTextHeight());
						}
						SDL_Flip(screen);
						SDL_Delay(0);
						SDL_Rect sideRect;
						sideRect.x = 0;
						sideRect.y = 0;
						sideRect.h = 600;
						sideRect.w = 300;
						while(SDL_PollEvent(&event)) {
							SDL_FillRect(screen,&sideRect,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
							if(event.type == SDL_QUIT) {
								bDone = true;
							}
							else if(event.key.keysym.sym == SDLK_RETURN) {
								if(!bLevelledUp) {
									bDone = true;
								}
							}
							else if(event.key.keysym.sym == SDLK_s && bLevelledUp) {
								player->stats.strength++;
								player->stats.hp_max += 4;
								bDone = true;
							}
							else if(event.key.keysym.sym == SDLK_d && bLevelledUp) {
								player->stats.dexterity++;
								bDone = true;
							}
							else if(event.key.keysym.sym == SDLK_i && bLevelledUp) {
								player->stats.intelligence++;
								player->stats.mp_max += 4;
								bDone = true;
							}
							else if(event.key.keysym.sym == SDLK_f && bLevelledUp) {
								player->stats.money += 1000;
								vars.currentTalk = "Got $1000 reward";
								vars.talkTimer = TALK_TIMER;
								bDone = true;
							}
						}
					}
				}
			}
		}
		SDL_LockSurface(screen);
		SDL_Flip(screen);
		SDL_UnlockSurface(screen);
		SDL_Delay(0);
		vars.timer_elapsed = SDL_GetTicks() - vars.timer_start;
		if(vars.timer_elapsed > 100.0f) {
			// Framerate limiter -- prevent collision cheaters!
			vars.timer_elapsed = 100.0f;
		}
		vars.timer_delta = vars.timer_elapsed/1000.0f;
		if(SDL_GetTicks() - lastFPScheck >= 1000) {
			lastFPScheck = SDL_GetTicks();
			vars.fps = frames;
			if(vars.fps > vars.fps_max) {
				vars.fps_max = vars.fps;
			}
			if(vars.fps > 0) {
				if(vars.fps < vars.fps_min) {
					vars.fps_min = vars.fps;
				}
			}
			frames = 0;
		}
		frames++;
	}
	printf("Frames : %i\nFPS: %f\n",vars.frames,vars.frames/(SDL_GetTicks()/1000.0f));
	vars.timer_elapsed = 0;
	vars.timer_delta = 0;
	vars.timer_start = SDL_GetTicks();
}