#include "csrpg2.h"
/*
	this file contains the classes for getting player input WHILE ROAMING.
 if you want the stuff for when you're fighting look in fight-input.cpp
*/

void CGame::getInput() {
	bool bMoved = false;
	while(SDL_PollEvent(&event)) {
		if(event.type == SDL_KEYDOWN) {
			if(event.key.keysym.sym == SDLK_ESCAPE) {
				inventoryMenu();
			}
			else if(event.key.keysym.sym == SDLK_F1) {
				saveGame("save");
				drawTextAt("Saving to disk, please wait...",0,0);
				SDL_Flip(screen);
			}
			else if(event.key.keysym.sym == SDLK_F2) {
				bPleaseLoadGame = true;
				bMustQuit = true;
				//loadGame("save");
			}
			else if(event.key.keysym.sym == SDLK_F3) {
				SDL_SaveBMP(screen,"sshot.bmp");
			}
			else if(event.key.keysym.sym == SDLK_RETURN) {
				startTalking();
			}
			else if(event.key.keysym.sym == SDLK_r) {
				// Look for a bed
				// Put this in the space bar menu too.
				findSleep();
			}
			else if(event.key.keysym.sym == SDLK_SPACE || event.key.keysym.sym == SDLK_g) {
				// Pick up nearby crap.
				pickupObjects();
			}
			else if(event.key.keysym.sym == SDLK_h) {
				keyHelp();
			}
		}
		else if(event.type == SDL_QUIT) {
			bMustQuit = true;
		}
	}
	bool bReallyDrunk = false;
	float delta = 0;
	if(vars.drunkenness == 0) {
		// Sober.
		delta = vars.timer_delta * PLAYER_SPEED;
	}
	else if(vars.drunkenness > 0 && vars.drunkenness < 2 ) {
		// Slightly buzzed.
		delta = vars.timer_delta * PLAYER_SPEED - 2*vars.drunkenness;
	}
	else {
		// Engineering keg party. Drunk as a skunk.
		delta = vars.timer_delta * PLAYER_SPEED - vars.drunkenness;
		bReallyDrunk = true;
	}
	Uint8* keystate = SDL_GetKeyState(NULL);
	int randDir = -1;
	if(bReallyDrunk) {
		vars.drunktimer += vars.timer_elapsed;
		if(vars.drunktimer > 200.0f) {
			randDir = rand() % 3;
			vars.drunktimer = 0.0f + (float)(rand() % 100);
		}
	}
	if(keystate[SDLK_UP] || randDir == 0) {
		bMoved = true;
		player->direction = 0;
		//if(!theMap->isSolid(player->x + 24, player->y - delta)) {
		if(!mapCollision(player->x, player->y - delta)) {
			if(!playerNPCcollision(player->x, player->y - delta)) {
				player->y -= delta;
			}
		}
		else if(vars.hasFloater) {
			if(theMap->isSea((player->x+24),(player->y - delta))) {
				if(!playerNPCcollision(player->x, player->y - delta)) {
					player->y -= delta;
				}
			}
		}
	}
	else if(keystate[SDLK_DOWN] || randDir == 1) {
		bMoved = true;
		player->direction = 2;
		//if(!theMap->isSolid((player->x + 24),(player->y + delta)+47)) {
		if(!mapCollision(player->x, player->y + delta)) {
			if(!playerNPCcollision(player->x, (player->y + delta))) {
				player->y += delta;
			}
		}
		else if(vars.hasFloater) {
			if(theMap->isSea((player->x+24),(player->y+delta)+47)) {
				if(!playerNPCcollision(player->x, (player->y + delta))) {
					player->y += delta;
				}
			}
		}
	}
	if(keystate[SDLK_LEFT] || randDir == 2) {
		bMoved = true;
		player->direction = 3;
		//if(!theMap->isSolid(player->x - delta, player->y + 24)) {
		if(!mapCollision(player->x - delta, player->y)) {
			if(!playerNPCcollision(player->x - delta, player->y)) {
				player->x -= delta;
			}
		}
		else if(vars.hasFloater) {
			if(theMap->isSea(player->x - delta, player->y + 24)) {
				if(!playerNPCcollision(player->x - delta, player->y)) {
					player->x -= delta;
				}
			}
		}
	}
	else if(keystate[SDLK_RIGHT] || randDir == 3) {
		bMoved = true;
		player->direction = 1;
		//if(!theMap->isSolid((player->x + delta) + 47, player->y + 24)) {
		if(!mapCollision(player->x + delta, player->y)) {
			if(!playerNPCcollision(player->x + delta, player->y)) {
				player->x += delta;
			}
		}
		else if(vars.hasFloater) {
			// Can walk on water
			if(theMap->isSea((player->x+delta)+47,player->y + 24)) {
				if(!playerNPCcollision(player->x + delta, player->y)) {
					player->x += delta;
				}
			}
		}
	}
	
	// Update animation and call appropriate other updates if bMoved is true.
	if(bMoved) {
		player->animate(vars.timer_elapsed);
	} else {
		player->walkFrame = 0;
	}
	list <Actor*>::iterator it;
	float px = player->x;
	float py = player->y; // prevent vtable lookup -- dunno if it will make difference
	for(it = actorList.begin(); it != actorList.end(); it++) {
		// this is probably inefficient?
		Actor *te = *it;
		if(te != player) {
			if(distance(te->x,te->y,px,py) < 500) {
				te->bIsActive = true;
			} else {
				te->bIsActive = false;
			}
		}
	}
}

void CGame::pollScreenshot() {
	while(SDL_PollEvent(&event)) {
		if(event.type == SDL_KEYDOWN) {
			if(event.key.keysym.sym == SDLK_F3) {
				SDL_SaveBMP(screen,"sshot.bmp");
			}
		}
	}
}