#include "csrpg2.h"

void CGame::inventoryMenu() {
	// Create a temporary vector of pointers to hold your items
	vector <Item*> yourStuff;
	for(unsigned int j = 0; j < itemVec.size(); j++) {
		if(itemVec[j]->owner == 1 && itemVec[j]->type != ITEM_DEAD) {
			yourStuff.push_back(itemVec[j]);
		}
	}
	bool bDone = false;
	SDL_Rect rect;
	rect.x = 15;
	rect.y = returnTextHeight();
	rect.w = 48;
	rect.h = 48;
	unsigned int menuchoice = yourStuff.size() - 1;
	unsigned int scroll = 0;
	unsigned int drawn = 0;
	while(!bDone) {
		rect.x = 15;
		drawn = 0;
		rect.y = returnTextHeight();
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
		drawTextAt("Player Inventory:",0,0);
		if(bPlayingGame) {
			drawTextAt("Press ESCAPE to go back, SPACE to view progress and save",0,600-returnTextHeight());
		} else {
			drawTextAt("Press ESCAPE to forfeit this turn",0,600-returnTextHeight());
		}
		char *cashText = new char[60];
		sprintf(cashText,"Your cash: $%i",player->stats.money);
		drawTextAt(cashText,10,500);
		delete[] cashText;
		// Draw the items
		if(yourStuff.size() < 1) {
			drawTextAt("You don't have anything in your inventory!",0,returnTextHeight());
			SDL_Flip(screen);
			while(!bDone) {
				while(SDL_PollEvent(&event)) {
					if(event.type == SDL_KEYDOWN || event.type == SDL_QUIT) {
						if(event.key.keysym.sym == SDLK_SPACE) {
							playerInfoScreen();
						}
						return;
					}
				}
			}
		} else {
			for(int i = yourStuff.size() - 1; i > -1; i--) {
				if(i - scroll < 0) {
					printf("Something broke, i-scroll out of range\n");
					break;
				}
				else if(yourStuff[i-scroll] && drawn <= 8) {
					// Draw nine icos to screen
					// Draw the "selection rectangle"
					if(i-scroll == menuchoice) {
						SDL_Rect temp;
						temp.x = rect.x;
						temp.y = rect.y;
						temp.w = 600;
						temp.h = 50;
						SDL_FillRect(screen,&temp,SDL_MapRGB(screen->format,100,0,0));
					}
					// Now draw the icon
					if(yourStuff[i-scroll]->icon < art.items.size()) {
						SDL_BlitSurface(art.items[yourStuff[i-scroll]->icon],NULL,screen,&rect);
					} else {
						fprintf(stderr,"Invalid item %i requested\n",yourStuff[i-scroll]->icon);
					}
					// Draw the text
					rect.x += 48;
					drawTextAt(yourStuff[i-scroll]->itemName.c_str(),rect.x,rect.y);
					// Draw description
					drawTextAt(yourStuff[i-scroll]->itemDescript.c_str(),rect.x,rect.y+returnTextHeight());
					// If equipped...
					if(yourStuff[i-scroll]->bIsEquipped == true) {
						drawTextAt("Equip",rect.x - 48, rect.y + returnTextHeight());
					}
					rect.x -= 48;
					rect.y += 49;	// Get in posn for next ico
					drawn++;
				}
				// Now draw the ... icons
				if(scroll > 0) {
					// Can scroll up.
					drawTextAt("...",600,returnTextHeight());
				}
				int size = yourStuff.size() - 1;
				if(size-(scroll+8) > 0 && (size > 8)) {
					// Blow away the extra icons :(
					drawTextAt("...",600,9 * 50);
				}
			}
		}
		SDL_Flip(screen);
		SDL_Delay(0);
		vars.frames++;
		
		// Poll for input
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_QUIT) {
				bMustQuit = true;
				bDone = true;
			}
			else if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_ESCAPE) {
					bDone = true;
				}
				else if(event.key.keysym.sym == SDLK_SPACE) {
					if(bPlayingGame) {
						playerInfoScreen();
					}
				}
				else if(event.key.keysym.sym == SDLK_UP) {
					if(menuchoice < yourStuff.size()-1) {
						menuchoice++;
					}
					int size = yourStuff.size() - 1;
					// Not sure why this isn't working and needed a major hack
					if((size - menuchoice) - scroll < 0 || (scroll > 0 && (size-menuchoice)-scroll <=0)) {
						printf("Scrolling up...\n");
						scroll--;	// Scroll up
					}
				}
				else if(event.key.keysym.sym == SDLK_DOWN) {
					if(menuchoice > 0) {
						menuchoice--;
					}
					int size = yourStuff.size() - 1;
					if((size - menuchoice) - scroll > 8) {
						printf("Scrolling down...\n");
						scroll++; // scroll down
					}
				}
				else if(event.key.keysym.sym == SDLK_F3) {
					SDL_SaveBMP(screen,"sshot-shop.bmp");
				}
				else if(event.key.keysym.sym == SDLK_RETURN) {
					if(yourStuff[menuchoice]->type == ITEM_INACTIVE || yourStuff[menuchoice]->type == ITEM_GIFT) {
						// Drop "stock dummy items"
						yourStuff[menuchoice]->x = player->x;
						yourStuff[menuchoice]->y = player->y;
						yourStuff[menuchoice]->owner = 0;
						bDone = true;
					}
					else if(yourStuff[menuchoice]->type == ITEM_BEER) {
						// Drink beer items
						if(vars.drunkenness < 4) {
							vars.drunkenness++;
							yourStuff[menuchoice]->type = ITEM_DEAD;
							vars.currentTalk = "*hic*";
						} else {
							vars.currentTalk = "You are already too drunk!";
						}
						vars.talkTimer = TALK_TIMER;
						bDone = true;
					}
					else if(yourStuff[menuchoice]->type == ITEM_KEYS) {
						printf("Trying to use key..\n");
						if(unlockDoor((player->x+24),(player->y+24),false, false) == 1) {
							printf("Ok, unlocked door.\n");
							yourStuff[menuchoice]->type = ITEM_DEAD;
							bDone = true;
						}
					}
					else if(yourStuff[menuchoice]->type == ITEM_ROOMKEY) {
						if(unlockDoor((player->x + 24), (player->y + 24), false, true) == 1) {
							yourStuff[menuchoice]->type = ITEM_DEAD;
							bDone = true;
							vars.currentTalk = "Welcome to Ravuya Resorts!";
							vars.talkTimer = TALK_TIMER;
						}
					}
					else if(yourStuff[menuchoice]->type == ITEM_PICK) {
						printf("Trying to pick door...\n");
						int result = unlockDoor((player->x+24),(player->y+24),true,false);
						vars.talkTimer = TALK_TIMER;
						if(result == 1) {
							printf("Ok, unlocked door.\n");
							vars.currentTalk = "Successfully picked the lock.";
							bDone = true;
						}
						else if(result == 2) {
							printf("Broke your pick!\n");
							vars.currentTalk = "Oh no! You broke your pick.";
							yourStuff[menuchoice]->type = ITEM_DEAD;
							bDone = true;
						}
						else if(result == 3) {
							vars.currentTalk = "Couldn't pick, try again";
							bDone = true;
						}
					}
					else if(yourStuff[menuchoice]->type == ITEM_ARMOR) {
						unequipAllItems(yourStuff);
						// When you start combat, put a pointer to armour in your fvars
						yourStuff[menuchoice]->bIsEquipped = true;
					}
					else if(yourStuff[menuchoice]->type == ITEM_FLOATER) {
						printf("Trying to equip this floater\n");
						yourStuff[menuchoice]->bIsEquipped = !yourStuff[menuchoice]->bIsEquipped;
						if(yourStuff[menuchoice]->bIsEquipped) {
							vars.hasFloater = true;
						}
						else {
							vars.hasFloater = false;
						}
					}
					else if(yourStuff[menuchoice]->type == ITEM_HEALING) {
						yourStuff[menuchoice]->type = ITEM_DEAD;
						player->stats.hp += yourStuff[menuchoice]->maxEffect;
						if(player->stats.hp > (int)player->stats.hp_max) {
							player->stats.hp = player->stats.hp_max;
						}
						bDone = true;
						vars.currentTalk = "Healed";
						vars.talkTimer = TALK_TIMER;
					}
					else if(yourStuff[menuchoice]->type == ITEM_MANA) {
						yourStuff[menuchoice]->type = ITEM_DEAD;
						player->stats.mp += yourStuff[menuchoice]->maxEffect;
						if(player->stats.mp > (int)player->stats.mp_max) {
							player->stats.mp = player->stats.mp_max;
						}
						bDone = true;
						vars.currentTalk = "Restored mana";
						vars.talkTimer = TALK_TIMER;
					}
					if(!bPlayingGame) {
						return; // Can only use one item per turn
					}
				}
			}
		}
	}
	vars.timer_start = SDL_GetTicks(); // Don't fuck up the timer
	vars.timer_elapsed = 0;
	vars.timer_delta = 0;
}

void CGame::buildWeaponVector(vector <Item*> &vec) {
	// Push pointers into an "inventory" vector
	for(Uint16 i = 0; i < itemVec.size(); i++) {
		if((itemVec[i]->type == ITEM_WEAPON || itemVec[i]->type == ITEM_BOW) && itemVec[i]->owner == 1) {
			vec.push_back(itemVec[i]);
		}
	}
}

void CGame::unequipAllItems(vector <Item*> vec) {
	for(unsigned int i = 0; i < vec.size(); i++) {
		if(vec[i]->type != ITEM_FLOATER) {
			vec[i]->bIsEquipped = false;
		}
	}
}