#include "item.h"
#include "defines.h"
#include <fstream>

// Appears to be some namespace confusion here, perhaps I should consider doing
// something else for these file references
//std::ifstream TheInputFileI;

int readNumberFromFileI(std::ifstream &TheInputFileI) {
	/*
	 Reads the next line out of the file and returns it as a
	 basic integer number
	 */
	char *line = new char[LINE_SIZE];
	TheInputFileI.getline(line,LINE_SIZE,'\n');
	return atoi(line);
}

string readStringFromFileI(std::ifstream &TheInputFileI) {
	/*
	 Reads the next line out of the file and returns it as a
	 C++/STL string
	 */
	char *line = new char[LINE_SIZE];
	TheInputFileI.getline(line,LINE_SIZE,'\n');
	string result = line;
	delete[] line;
	return result;
}

void writeStringToFileI(string enter, std::ofstream &TheOutputFileI) {
	/*
	 Write the string into the file and then end with a newline
	 */
	TheOutputFileI << enter.c_str();
	TheOutputFileI << "\n";
}

void writeNumberToFileI(int number, std::ofstream &TheOutputFileI) {
	/*
	 Write the number into the file and end with a newline
	 */
	TheOutputFileI << number;
	TheOutputFileI << "\n";
}

void Item::serializeTo(char *filename) {
	std::ofstream TheOutputFileI;
	TheOutputFileI.open(filename);
	writeNumberToFileI(type, TheOutputFileI);
	writeNumberToFileI(maxEffect, TheOutputFileI);
	writeNumberToFileI(price, TheOutputFileI);
	writeNumberToFileI(owner, TheOutputFileI);
	writeNumberToFileI((int)x, TheOutputFileI);
	writeNumberToFileI((int)y, TheOutputFileI);
	if(bIsEquipped) {
		writeNumberToFileI(1, TheOutputFileI);
	} else {
		writeNumberToFileI(0, TheOutputFileI);
	}
	writeStringToFileI(itemName, TheOutputFileI);
	writeStringToFileI(itemDescript, TheOutputFileI);
	writeStringToFileI(shortName, TheOutputFileI);
	writeNumberToFileI(icon, TheOutputFileI);
	if(type == ITEM_BOW) {
		writeNumberToFileI(range, TheOutputFileI);
	} else {
		writeNumberToFileI(0, TheOutputFileI);
	}
	TheOutputFileI.close();
	//TheInputFileI.close();
}

int Item::serializeFrom(char *filename) {
	std::ifstream TheInputFileI;
	TheInputFileI.open(filename);
	if(!TheInputFileI) {
		fprintf(stderr,"***WARNING*** file %s not found. You can probably ignore this\n",filename);
		TheInputFileI.close();
		//TheOutputFileI.close();
		return -1;
	}
	type = readNumberFromFileI(TheInputFileI);
	maxEffect = readNumberFromFileI(TheInputFileI);
	price = readNumberFromFileI(TheInputFileI);
	owner = abs(readNumberFromFileI(TheInputFileI));
	x = (float)readNumberFromFileI(TheInputFileI);
	y = (float)readNumberFromFileI(TheInputFileI);
	if(readNumberFromFileI(TheInputFileI) > 0) {
		bIsEquipped = true;
	} else {
		bIsEquipped = false;
	}
	itemName = readStringFromFileI(TheInputFileI);
	itemDescript = readStringFromFileI(TheInputFileI);
	shortName = readStringFromFileI(TheInputFileI);
	icon = readNumberFromFileI(TheInputFileI);
	if(type == ITEM_BOW) {
		printf("Weapon is a long-range item, checking range\n");
		range = readNumberFromFileI(TheInputFileI);
	}
	TheInputFileI.close();
	//TheOutputFileI.close(TheInputFileI);
	//printf("Item %s at %i,%i\n",itemName.c_str(),(int)x,(int)y);
	return 0;
}