#ifndef _ITEM_H_
#define _ITEM_H_

#include <string>
using namespace std;

class Item {
public:
	int type;						/// Depends on defines.h
	int maxEffect;					/// Heals 0-maxEffect, damages... etc
	int price;						/// Price at the shop, when sold you get price/2 back
	unsigned int owner;				/// 0 = world, 1 = shop, 2 = player
	float x, y;						/// (x,y) location in world
	bool bIsEquipped;				/// Is the player actively handling it?
	string itemName;				/// Name of item
	string shortName;				/// Short name of item (used for quest reference)
	string itemDescript;			/// Short description of item
	unsigned int icon;				/// What sprite to paint this as?
	int range;						/// Maximum range of weapon (only loaded if type == ITEM_BOW)
	
	Item();
	void serializeTo(char *filename);
	int serializeFrom(char *filename);
	/*int readNumberFromFile();
	void writeNumberToFile();
	string readStringFromFile();
	string writeStringToFile();*/
};

#endif