#include "csrpg2.h"

// Damn, can't reduce my draw range anymore.
#define T_RANGE_X 11
#define T_RANGE_Y 9

void CGame::drawMap() {
	/*
		Draw the tiles to screen.
		Sprites are managed elsewhere
	*/
	SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,26,26,168)); // "sea blue"
	SDL_Rect temprect = {0,0,0,0};
	SDL_Surface *temptile;
	int tx = (int)(player->x / 48);
	int ty = (int)(player->y / 48); // Starting tile.
	int xoff = 0;
	if(SCREEN_WIDTH == 1024) {
		xoff = 2;
	}
	// Precalculation.
	Sint16 offsetx = (Sint16)((player->x)-((SCREEN_WIDTH/2)-48));
	Sint16 offsety = (Sint16)((player->y)-252);
	for(int r = (ty - T_RANGE_Y); r < (ty + T_RANGE_Y); r++) {
		for(int c = (tx - T_RANGE_X); c < (tx + T_RANGE_X + xoff); c++) {
			if(c < 0) { c = 0; }
			if(r < 0) { r = 0; }
			if(r > MAPHEIGHT) { continue; }
			if(c > MAPHEIGHT) { continue; }
			temprect.y = (r*48)-(offsety); // Precalculating this makes things messy as all hell
			temprect.x = (c*48)-(offsetx);
			
			temptile = art.tiles[theMap->getTileAt(c,r)];
			if(theMap->getTileAt(c,r) < 0) {
				printf("invalid tile : %i,%i\n",c,r);
				temptile = art.tiles[0];
			}
			if(vars.bFastWater) {
				if(theMap->getTileAt(c,r) != 21) {
					// Obscure water. 3-4 fps increase.
					SDL_BlitSurface(temptile,NULL,screen,&temprect);
				}
			} else {
				// Slow blit.
				SDL_BlitSurface(temptile,NULL,screen,&temprect);
			}
		}
	}
}