#include "csrpg2.h"

void CGame::menuLoop() {
	int pos = 1;
	SDL_Rect cursRect;
	cursRect.x = 0;
	char *gameTitle = new char[80];
	sprintf(gameTitle,"%s: Powered by CSRPG2",vars.gameName.c_str());
	while(!bMustQuit) {
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
		drawTextAt(gameTitle,10,10);
		drawTextAt("New Game",20,20+returnTextHeight());
		drawTextAt("Tutorial",20,20+(returnTextHeight()*2));
		drawTextAt("Load Game",20,20+(returnTextHeight()*3));
		drawTextAt("Credits",20,20+(returnTextHeight()*4));
		drawTextAt("Exit",20,20+(returnTextHeight()*5));
		drawTextAt("Launch Custom Game...",20,20+(returnTextHeight()*6));
		if(audio.bSoundOff) {
			drawTextAt("Turn sound on",20,20+(returnTextHeight()*7));
		} else {
			drawTextAt("Turn sound off",20,20+(returnTextHeight()*7));
		}
		//drawTextAt("Toggle Full Screen",20,20+(returnTextHeight()*6));
		cursRect.y = 20+returnTextHeight() * pos;
		SDL_BlitSurface(art.icons[0],NULL,screen,&cursRect);
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_QUIT) {
				bMustQuit = true;
			}
			if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_UP) {
					pos--;
					if(pos < 1) {
						pos = 7;
					}
				}
				else if(event.key.keysym.sym == SDLK_DOWN) {
					pos++;
					if(pos > 7) {
						pos = 1;
					}
				}
				else if(event.key.keysym.sym == SDLK_ESCAPE) {
					bMustQuit = true;
				}
				else if(event.key.keysym.sym == SDLK_e) {
					// Ending cheat
					loadAndShowEnding("data");
				}
				else if(event.key.keysym.sym == SDLK_RETURN || event.key.keysym.sym == SDLK_SPACE) {
					if(pos == 1) {
						// new game
						//loadAndShowEnding("data"); // DEBUG ONLY DEBUG ONLY DEBUG ONLY
						if(loadGame("data") == 0) {
							ScrollyText("data/intro.txt");
							gameLoop();
						} else {
							errorDialogue("Can't find data folder, or data is corrupt.");
						}
					}
					else if(pos == 2) {
						if(loadGame("tutorial") == 0) {
							ScrollyText("tutorial/intro.txt");
							gameLoop();
						} else {
							errorDialogue("Can't find tutorial folder, or tutorial is corrupt.");
						}
					}
					else if(pos == 3) {
						// load game
						if(loadGame("save") == 0) {
							gameLoop();
						} else {
							errorDialogue("That save game doesn't exist");
						}
					}
					else if(pos == 4) {
						// credits
						ScrollyText("data/credits.txt");
					}
					else if(pos == 5) {
						bMustQuit = true;
					}
					else if(pos == 6) {
						// load "custom module" from a directory.
						string fName;
						// Now put in a screen where the pinhead user can specify the name of the dir.
						// How to do this???
						fName = inputLoop();
						printf("Loading game! %s\n",fName.c_str());
						if(loadGame((char*)fName.c_str()) == 0) {
							char *name = new char[50];
							sprintf(name,"%s/intro.txt",fName.c_str());
							ScrollyText(name);
							delete[] name;
							gameLoop(); // FIXME: Can't run game yet
						} else {
							errorDialogue("Can't load that game...");
						}
					}
					else if(pos == 7) {
						audio.bSoundOff = !audio.bSoundOff;
					}
					else {
						raiseError("Finger out of bounds\n");
						pos = 1;
					}
				}
			}
		}
		vars.frames++;
		SDL_Flip(screen);
		SDL_Delay(0); // prevent 100% cpu load
	}
	vars.timer_elapsed = 0;
	vars.timer_delta = 0;
	vars.timer_start = SDL_GetTicks();
	delete[] gameTitle;
}