#include "csrpg2.h"

void CGame::playerInfoScreen() {
	/*
		Display the hacked-together player information screen.
		It updates you on your collection and lets you know if you have missed any items
		around the game world.
	*/
	bool bDoneHere = false;
	vector <Item*> playerItems;
	rebuildShopVector(playerItems,itemVec,1,-1);
	// Precalculate data
	int your_items = (int)playerItems.size();
	int max_items = (int)itemVec.size();
	int your_quests = 0;
	// Debug only
	printf("setting up player data...\n");
	list <Quest*>::iterator it;
	for(it = questList.begin(); it != questList.end(); it++) {
		Quest *tq = *it;
		if(tq->bIsCompleted) {
			your_quests++;
		}
	}
	int max_quests = (int)questList.size();
	char *str = new char[70];
	while(!bDoneHere) {
		// display all of the text in a god-awful fashion
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
		//drawTextAt("Player Status",10,10);
		sprintf(str,"%s's Status",player->myName.c_str());
		drawTextAt(str,10,10);
		sprintf(str,"HP: %i/%i",player->stats.hp,player->stats.hp_max);
		drawTextAt(str,10,10 + returnTextHeight() );
		sprintf(str,"MP: %i/%i",player->stats.mp,player->stats.mp_max);
		drawTextAt(str,10,10 + returnTextHeight()*2 );
		sprintf(str,"XP: %i/4 Level: %i",player->stats.xp,player->stats.level);
		drawTextAt(str,10,10 + returnTextHeight()*3 );
		sprintf(str,"Gold: $%i",player->stats.money);
		drawTextAt(str,10,10 + returnTextHeight()*4 );
		sprintf(str,"Strength: %i Dexterity: %i",player->stats.strength,player->stats.dexterity);
		drawTextAt(str,10,10 + returnTextHeight()*5 );
		sprintf(str,"Intelligence: %i",player->stats.intelligence);
		drawTextAt(str,10,10 + returnTextHeight()*6 );
		sprintf(str,"Items: %i/%i",your_items,max_items);
		drawTextAt(str,10,10 + returnTextHeight()*8 );
		sprintf(str,"Quests: %i/%i",your_quests,max_quests);
		drawTextAt(str,10,10 + returnTextHeight()*9 );
		drawTextAt("Press escape to exit, S to save",10,600 - returnTextHeight());
		SDL_Flip(screen);
		SDL_Delay(0);
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_ESCAPE) {
					bDoneHere = true;
				}
				else if(event.key.keysym.sym == SDLK_s) {
					// Save game...
					drawTextAt("Saving...",0,0);
					SDL_Flip(screen);
					saveGame("save");
					SDL_Delay(100);
				}
			}
			else if(event.type == SDL_QUIT) {
				bDoneHere = true;
			}
		}
	}
	delete[] str;
	vars.timer_elapsed = 0;
	vars.timer_delta = 0;
	vars.timer_start = SDL_GetTicks();
}