#include "player.h"

/*
	Some player-based utilities
*/

bool Actor::canSee(float px, float py, Map* theMap) {
	/*
		Uses the bresenham algorithm to determine if the character can see to a certain
		(x,y) point or if they are blocked by solid things other than water
	*/
	/* Okay, let's do a Bresenham algorithm... */
	int tx1, tx2, ty1, ty2; // Tiles for Bresenham
	if(px <= x) {
		tx1 = (int)(px / 48);
		tx2 = (int)(x / 48);
	} else {
		tx2 = (int)(px / 48);
		tx1 = (int)(x / 48);
	}
	if(py <= y) {
		ty1 = (int)(py / 48);
		ty2 = (int)(y / 48);
	} else {
		ty1 = (int)(y / 48);
		ty2 = (int)(py / 48);
	}
	// Okay, now do the Bresenham algorithm and iterate through the loop to determine if we are
	// going to hit a wall. If we do, then return.
	
	int eps = 0;
	int dx = tx2 - tx1;
	int dy = ty2 - ty1;
	int y = ty1;
	if(tx2 < tx1) {
		printf("tx2 < tx1\n");
	}
	if(ty2 < ty1) {
		printf("ty2 < ty1\n");
	}
	int reps = 0;
	//printf("Starting at: %i,%i\n",tx1,ty1);
	for(int x = tx1; x <= tx2; x++) {
		reps++;
		if(reps > 16) {
			// I can't see very far.
			return false;
		}
		//printf("Testing: %i,%i Content: %i\n",x,y,theMap->level[y][x]);
		if(theMap->isSolid(x*48,y*48) && !theMap->isSea(x*48,y*48)) {
			//printf("Wall hit at %i,%i\n",x,y);
			return false;
		}
		eps += dy;
		if((eps << 1) >= dx) {
			y++;
			eps -= dx;
		}
		if(x == tx2 && y < ty2) {
			x--; // fudge it
		}
	}
	//printf("I SAW YOU!!!!\n");
	return true; // I SEEEEEE YOOOOOOOOO
}