#include "quest.h"
#include <fstream>
#include "defines.h"
using namespace std;

int readNumberFromFileQ(std::ifstream &TheInputFileQ) {
	/*
	 Reads the next line out of the file and returns it as a
	 basic integer number
	 */
	char *line = new char[LINE_SIZE];
	TheInputFileQ.getline(line,LINE_SIZE,'\n');
	return atoi(line);
}

string readStringFromFileQ(std::ifstream &TheInputFileQ) {
	/*
	 Reads the next line out of the file and returns it as a
	 C++/STL string
	 */
	char *line = new char[LINE_SIZE];
	TheInputFileQ.getline(line,LINE_SIZE,'\n');
	string result = line;
	delete[] line;
	return result;
}

void writeStringToFileQ(string enter, std::ofstream &TheOutputFileQ) {
	/*
	 Write the string into the file and then end with a newline
	 */
	TheOutputFileQ << enter.c_str();
	TheOutputFileQ << "\n";
}

void writeNumberToFileQ(int number, std::ofstream &TheOutputFileQ) {
	/*
	 Write the number into the file and end with a newline
	 */
	TheOutputFileQ << number;
	TheOutputFileQ << "\n";
}

void Quest::serializeTo(char *filename) {
	std::ofstream TheOutputFileQ;
	TheOutputFileQ.open(filename);
	writeStringToFileQ(description, TheOutputFileQ);
	writeStringToFileQ(itemTarget, TheOutputFileQ);
	writeNumberToFileQ(reward, TheOutputFileQ);
	if(bIsCompleted) {
		writeNumberToFileQ(1, TheOutputFileQ);
	} else {
		writeNumberToFileQ(0, TheOutputFileQ);
	}
	writeNumberToFileQ(flagId, TheOutputFileQ);
	TheOutputFileQ.close();
}

int Quest::serializeFrom(char *filename) {
	std::ifstream TheInputFileQ;
	TheInputFileQ.open(filename);
	if(!TheInputFileQ) {
		TheInputFileQ.close();
		return -1;
	}
	description = readStringFromFileQ(TheInputFileQ);
	itemTarget = readStringFromFileQ(TheInputFileQ);
	reward = readNumberFromFileQ(TheInputFileQ);
	if(readNumberFromFileQ(TheInputFileQ) > 0) {
		bIsCompleted = true;
	} else {
		bIsCompleted = false;
	}
	flagId = readNumberFromFileQ(TheInputFileQ);
	TheInputFileQ.close();
	return 0;
}