#include "csrpg2.h"

/*
	questmgr.cpp
	Holds all of Dr. Questy's management code,
	to determine what quests have been fulfilled,
	and if not gives them to you and sets the proper
	"event flags" so that NPCs in the game world may know
	that you are on this task.
 
	It is not particularly fast, but it is not like there
	will be large numbers of quests provided to the game engine
	to make my searching method poor.
*/

string CGame::getNextQuest() {
	/*
		Here's where the entire quest system goes.
	*/
	bool bFoundIt = false;									// Protection in case a quest references an item that
															// doesn't exist.
	list <Quest*>::iterator it;
	for(it = questList.begin(); it != questList.end(); it++) {
		Quest *tq = *it;
		if(!tq->bIsCompleted) {
			// First check to see if it's done.
			for(unsigned int i = 0; i < itemVec.size(); i++) {
				if(itemVec[i]->shortName == tq->itemTarget && itemVec[i]->type != ITEM_DEAD) {
					bFoundIt = true;						// This item exists in the world
					if(itemVec[i]->owner == 1) {
						// Ok, you got it.
						tq->bIsCompleted = true;
						itemVec[i]->owner = 6;					// Mr. Questy's Item Collection.
						player->stats.money += tq->reward;
						return "Good work, you found the " + itemVec[i]->itemName + ".";
					}
					//break;										// Possible optimization, check this out
				}
			}
			if(!bFoundIt) {
				tq->bIsCompleted = true;
				return "I can't find the item for this quest! Never mind.";
			}
			// If not...
			vars.flags[tq->flagId] = true; // Set the convo flag.
			return tq->description;
		}
	}
	return "I do not have anything for you at this time.";
}