#include "player.h"
#include "quest.h"
#include "item.h"
#include "csrpg2.h"

void CGame::loadActors(char *dir) {
	/// NEED TO CLEAR CURRENT ACTORS IN MEMORY!!!
	bool bStillLoading = 1;
	Uint32 i = 0;
	while(bStillLoading) {
		char *filename = new char[60];
		sprintf(filename,"%s/npcdef/%i.def",dir,i);
		Actor *newActor = new Actor();
		if(newActor->serializeFrom(filename) != 0) {
			if(i == 0) {
				fprintf(stderr,"*** ERROR *** DATA DIR %s IS MISSING filename %s\n",dir,filename);
				exit(1);
			}
			delete newActor;
			bStillLoading = 0;
		} else {
			actorList.push_back(newActor);
		}
		i++;
		delete[] filename;
	}
}

void CGame::loadItems(char *dir) {
	bool bStillLoading = 1;
	Uint32 i = 0;
	while(bStillLoading) {
		char *filename = new char[60];
		sprintf(filename,"%s/idef/%i.def",dir,i);
		Item *newItem = new Item();
		if(newItem->serializeFrom(filename) != 0) {
			if(i == 0) {
				fprintf(stderr,"*** ERROR *** DATA DIR %s IS MISSING\n",dir);
				exit(1);
			}
			delete newItem;
			bStillLoading = 0;
		} else {
			itemVec.push_back(newItem);
		}
		i++;
		delete[] filename;
	}
}

void CGame::loadQuests(char *dir) {
	char *filename = new char[60];
	bool bStillLoading = 1;
	Uint32 i = 0;
	while(bStillLoading) {
		sprintf(filename,"%s/qdef/%i.def",dir,i);
		Quest *newQuest = new Quest();
		if(newQuest->serializeFrom(filename) != 0) {
			if(i == 0) {
				fprintf(stderr,"*** ERROR *** DATA DIR %s IS MISSING\n",dir);
				exit(1);
			}
			delete newQuest;
			bStillLoading = 0;
		} else {
			questList.push_back(newQuest);
		}
		i++;
	}
	delete[] filename;
}

void CGame::saveActors(char *dir) {
	int i = 0;
	list <Actor*>::iterator ait;
	for(ait = actorList.begin(); ait != actorList.end(); ait++) {
		char *filename = new char[60];
		sprintf(filename,"%s/npcdef/%i.def",dir,i);
		Actor* ap = *ait;
		ap->serializeTo(filename);
		i++;
		delete[] filename;
	}
}

void CGame::saveItems(char *dir) {
	printf("There are %i items in the item vector\n",(int)itemVec.size());
	for(unsigned i = 0; i < itemVec.size(); i++) {
		char *filename = new char[60];
		sprintf(filename,"%s/idef/%i.def",dir,i);
		Item* ap = itemVec[i];
		ap->serializeTo(filename);
		delete[] filename;
	}
}

void CGame::saveQuests(char *dir) {
	int i = 0;
	list <Quest*>::iterator ait;
	for(ait = questList.begin(); ait != questList.end(); ait++) {
		char *filename = new char[60];
		sprintf(filename,"%s/qdef/%i.def",dir,i);
		Quest* ap = *ait;
		ap->serializeTo(filename);
		i++;
		delete[] filename;
	}
}