#include "csrpg2.h"

void CGame::rebuildShopVector(vector <Item*> &shopVec, vector <Item*> itemVec, int owner, int type) {
	shopVec.clear();
	for(unsigned int j = 0; j < itemVec.size(); j++) {
		if(itemVec[j]->owner == (unsigned int)owner && itemVec[j]->type != ITEM_DEAD) {
			if((type == -1 && itemVec[j]->type != ITEM_ROOMKEY && itemVec[j]->type != ITEM_GIFT) || 
			   (itemVec[j]->type == type || (itemVec[j]->type == ITEM_GIFT && type != -1))) {
				shopVec.push_back(itemVec[j]);
			}
		}
	}
}

void CGame::shopLoop(int type) {
	bool bDoneShopping = false;
	bool bIsSellingItems = false;
	vector <Item*> shopVec;
	SDL_Rect rect;
	bool bDonePicking = false;
	int clickerPos = 0;
	while(!bDonePicking) {
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
		drawTextAt("Welcome to the shop.",10,0);
		drawTextAt("Buy item",20,returnTextHeight());
		drawTextAt("Sell item",20,returnTextHeight()*2);
		drawTextAt("Never mind",20,returnTextHeight()*3);
		SDL_Rect rect;
		rect.x = 0;
		rect.y = (clickerPos+1) * returnTextHeight();
		rect.w = 10;
		rect.h = 10;
		SDL_BlitSurface(art.icons[0],NULL,screen,&rect);
		SDL_Flip(screen);
		SDL_Delay(0);
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_QUIT) {
				return;
			}
			else if(event.type == SDL_KEYDOWN) {
				if(event.key.keysym.sym == SDLK_UP) {
					if(clickerPos > 0) {
						clickerPos--;
					}
				}
				else if(event.key.keysym.sym == SDLK_DOWN) {
					if(clickerPos < 2) {
						clickerPos++;
					}
				}
				else {
					switch(clickerPos) {
						case 0:
							bIsSellingItems = false;
							bDonePicking = true;
							rebuildShopVector(shopVec,itemVec,2,type);
							break;
						case 1:
							bIsSellingItems = true;
							bDonePicking = true;
							rebuildShopVector(shopVec,itemVec,1,type);
							break;
						case 2:
							return;
					}
				}
			}
		}
		vars.frames++;
	}
	unsigned int scroll = 0;
	unsigned int drawn = 0;
	unsigned int menuchoice = shopVec.size() - 1; // the list is in reverse.
	char *cashText = new char[60];
	while(!bDoneShopping) {
		SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
		rect.x = 15;
		drawn = 0;
		rect.y = returnTextHeight();
		drawTextAt("Welcome to the shop.",10,0);
		sprintf(cashText,"Money: $%i",player->stats.money);
		drawTextAt(cashText,10,500);
		if(!bIsSellingItems) {
			drawTextAt("You are BUYING some items.",10,500 + returnTextHeight());
		} else {
			drawTextAt("You are SELLING some items.",10, 500 + returnTextHeight());
		}
		if(shopVec.size() > 0) {
			// Draw
			for(int i = shopVec.size() -1; i > -1; i--) {
				if(i - scroll < 0) {
					fprintf(stderr,"i-scroll went negative\n");
					break;
				}
				else if(shopVec[i-scroll] && drawn <= 8) {
					if(i-scroll == menuchoice) {
						// Draw selection rectangle
						SDL_Rect temp;
						temp.x = rect.x;
						temp.y = rect.y;
						temp.w = 600;
						temp.h = 50;
						SDL_FillRect(screen,&temp,SDL_MapRGB(screen->format,100,0,0));
					}
					// Draw icon
					//SDL_BlitSurface(art.items[shopVec[i-scroll]->icon],NULL,screen,&rect);
					if(shopVec[i-scroll]->icon < art.items.size()) {
						SDL_BlitSurface(art.items[shopVec[i-scroll]->icon],NULL,screen,&rect);
					} else {
						fprintf(stderr,"Invalid item %i requested\n",shopVec[i-scroll]->icon);
					}
					// Draw text
					rect.x += 48;
					drawTextAt(shopVec[i-scroll]->itemName.c_str(),rect.x,rect.y);
					// Draw description
					//drawTextAt(shopVec[i-scroll]->itemDescript.c_str(),rect.x,rect.y+returnTextHeight());
					char *descript = new char[200];
					if(!bIsSellingItems) {
						sprintf(descript,"%s | cost: %i",shopVec[i-scroll]->itemDescript.c_str(),shopVec[i-scroll]->price);
					} else {
						sprintf(descript,"%s | resale: %i",shopVec[i-scroll]->itemDescript.c_str(),(int)(shopVec[i-scroll]->price/2));
					}
					drawTextAt(descript,rect.x, rect.y + returnTextHeight());
					delete[] descript;
					rect.x -= 48;
					rect.y += 49;	// Get in posn for next ico
					drawn++;
				}
			}
			
			// Now draw the ... icons
			if(scroll > 0) {
				// Can scroll up.
				drawTextAt("...",600,returnTextHeight());
			}
			int size = shopVec.size() - 1;
			if(size-(scroll+8) > 0 && (size > 8)) {
				// Blow away the extra icons :(
				drawTextAt("...",600,9 * 50);
			}
			
			// Input
			while(SDL_PollEvent(&event)) {
				if(event.type == SDL_KEYDOWN) {
					if(event.key.keysym.sym == SDLK_ESCAPE) {
						bDoneShopping = true;
					}
					else if(event.key.keysym.sym == SDLK_RETURN) {
						if(bIsSellingItems) {
							player->stats.money += (int)(shopVec[menuchoice]->price / 2);
							shopVec[menuchoice]->owner = 2;
							rebuildShopVector(shopVec,itemVec,1,type);
							scroll = 0;
							menuchoice = shopVec.size() - 1;
						}
						else {
							if((int)player->stats.money < shopVec[menuchoice]->price) {
								drawTextAt("Sorry, you don't have enough money!",10,480);
								SDL_Flip(screen);
								SDL_Delay(800);
							} else {
								shopVec[menuchoice]->owner = 1;
								player->stats.money -= shopVec[menuchoice]->price;
								rebuildShopVector(shopVec,itemVec,2,type);
								scroll = 0;
								menuchoice = shopVec.size() - 1; // Don't point to a nonexistant item, just reset
							}
						}
					}
					else if(event.key.keysym.sym == SDLK_UP) {
						if(menuchoice < shopVec.size()-1) {
							menuchoice++;
						}
						int size = shopVec.size() - 1;
						// Not sure why this isn't working and needed a major hack
						if((size - menuchoice) - scroll < 0 || (scroll > 0 && (size-menuchoice)-scroll <=0)) {
							printf("Scrolling up...\n");
							scroll--;	// Scroll up
						}
					}
					else if(event.key.keysym.sym == SDLK_DOWN) {
						if(menuchoice > 0) {
							menuchoice--;
						}
						int size = shopVec.size() - 1;
						if((size - menuchoice) - scroll > 8) {
							printf("Scrolling down...\n");
							scroll++; // scroll down
						}
					}
				}
				else if(event.type == SDL_QUIT) {
					bDoneShopping = true;
				}
			}
			vars.frames++;
		} else {
			if(!bIsSellingItems) {
				drawTextAt("Oh no! We're sold completely out.",10,30);
			} else{
				drawTextAt("You don't appear to have anything I can buy.",10,30);
			}
			SDL_Flip(screen);
			vars.frames++;
			bool bDoneHere = false;
			while(!bDoneHere) {
				while(SDL_PollEvent(&event)) {
					if(event.type == SDL_KEYDOWN || event.type == SDL_QUIT) {
						if(event.key.keysym.sym == SDLK_s) {
							bIsSellingItems = !bIsSellingItems;
							if(bIsSellingItems) {
								rebuildShopVector(shopVec,itemVec,1,type);
							} else {
								rebuildShopVector(shopVec,itemVec,2,type);
							}
							bDoneHere = true;
						}
						else {
							return;
						}
					}
				}
				SDL_Delay(0);
			}
		}
		SDL_Flip(screen);
		SDL_Delay(0);
	}
	vars.timer_start = SDL_GetTicks();
	vars.timer_elapsed = 0;
	vars.timer_delta = 0;
	//itemVec.clear();
	delete[] cashText;
}