#include "vars.h"
#include "SDL_mixer.h"
#include "csrpg2.h"


void CGame::playSound(int number) {
	/*
		Requests the number from the sound manager system, and then
		plays it or fails.
	 
		Additional error checking is in place to prevent a request for a
		sound that does not exist/is outside of the MAX_SOUNDS definition.
	*/
	if(audio.bSoundOff) {
		return;
	}
	else {
		if(number < MAX_SOUNDS && audio.sfx[number]) {
			Mix_PlayChannel(-1,audio.sfx[number],0);
		}
		else {
			char *err = new char[90];
			sprintf(err,"sound %i is missing, out of range or damaged\n",number);
			raiseError(err);
			delete[] err;
		}
	}
}