#include "csrpg2.h"

#define LEFT_OFFSET 4
#define RIGHT_OFFSET 44

bool CGame::mapCollision(float x, float y) {
	/*
		x, y: TOP LEFT CORNER of target location
		
		assumes a 48x48 sprite, checks (x+2, y+2) (x+2, y+46) (x+46, y+46)
								and (x+46, y+2)
	 */
	
	if(!theMap->isSolid(x+LEFT_OFFSET, y+LEFT_OFFSET)) {
		if(!theMap->isSolid(x+LEFT_OFFSET, y+RIGHT_OFFSET)) {
			if(!theMap->isSolid(x+RIGHT_OFFSET, y+RIGHT_OFFSET)) {
				if(!theMap->isSolid(x+RIGHT_OFFSET, y+LEFT_OFFSET)) {
					return false;
				}
			}
		}
	}
	return true;
}

bool CGame::NPCcollision(float x, float y, Actor *oa) {
	list <Actor*>::iterator lit;
	for(lit = actorList.begin(); lit != actorList.end(); lit++) {
		Actor* te = *lit;
		if(te->x != oa->x && te->y != oa->y) {
			if(spriteCollision(x,y,48,48,te->x,te->y,48,48)) {
				return true;
			}
		}
	}
	return false;
}

bool CGame::combatCollide(Actor* a1, Actor *a2, int dx, int dy) {
	if(spriteCollision((a1->x + dx),(a1->y + dy),46,46,a2->x,a2->y,46,46)) {
		return true;
	}
	return false;
}

bool CGame::playerNPCcollision(float x, float y) {
	list <Actor*>::iterator lit;
	for(lit = actorList.begin(); lit != actorList.end(); lit++) {
		Actor* te = *lit;
		if(te->x != player->x && te->y != player->y) {
			if(spriteCollision(x,y,48,48,te->x,te->y,48,48)) {
				return true;
			}
		}
	}
	return false;
}

bool CGame::spriteCollision(float ax, float ay, float aw, float ah, float bx, float by, float bw, float bh) {
	if((ay+ah) < by) { return false; }
	if(ay > (by + bh)) { return false; }
	if((ax+aw) < bx) { return false; }
	if(ax > (bx + bw)) { return false; }
	return true;
}