#include "csrpg2.h"

void CGame::drawSprites() {
	SDL_Rect dr;
	// Draw items first so we can walk on them
	for(unsigned int i = 0; i < itemVec.size(); i++) {
		if(itemVec[i]->owner == 0) {
			// Owned by world.
			dr.x = ((SCREEN_WIDTH/2)-48) - (Sint16)((player->x)-(itemVec[i]->x));
			dr.y = 252 - (Sint16)((player->y)-(itemVec[i]->y));
			if(dr.x > -20 && dr.x < SCREEN_WIDTH && dr.y < 600 && dr.y > -20) {
				if(itemVec[i]->icon < art.items.size()) {
					SDL_BlitSurface(art.items[itemVec[i]->icon],NULL,screen,&dr);
				} else {
					fprintf(stderr,"Invalid item %i requested\n",itemVec[i]->icon);
				}
			}
		}
	}
	// Draw actors last so they're on top
	list <Actor*>::iterator ait;
	for(ait = actorList.begin(); ait != actorList.end(); ait++) {
		Actor *act = *ait;
		dr.x = ((SCREEN_WIDTH/2)-48) - (Sint16)((player->x)-(act->x));
		dr.y = 252 - (Sint16)((player->y)-(act->y));
		if(bPlayingGame) {
			if(dr.x > -20 && dr.x < SCREEN_WIDTH && dr.y < 600 && dr.y > -20) {
				SDL_BlitSurface(art.sprites[act->sprite][act->direction][act->walkFrame],NULL,screen,&dr);
			}
		} else {
			if(act == player || act == enemy) {
				// Ignore all other NPCs
				if(dr.x > -20 && dr.x < SCREEN_WIDTH && dr.y < 600 && dr.y > -20) {
					SDL_BlitSurface(art.sprites[act->sprite][act->direction][act->walkFrame],NULL,screen,&dr);
				}
			}
		}
	}
}