#include "csrpg2.h"
#include "math.h"

float CGame::distance(float ax, float ay, float bx, float by) {
	return sqrtf(((bx-ax)*(bx-ax))+((by-ay)*(by-ay)));
}

void CGame::startTalking() {
	/*
		Find an NPC of suitable distance and then yell to them, they will yell back.
	 
		Depending on the type of NPC they will activate other reactions:
		* Quest giving
		* Shop opening
		* Gamble orgy providing
	 
		Future developers might want to add hookers.
	*/
	printf("Talking..\n");
	vars.talkTimer = 0.0f;
	list <Actor*>::iterator ait;
	for(ait = actorList.begin(); ait != actorList.end(); ait++) {
		Actor *te = *ait;
		if((distance(te->x,te->y,player->x,player->y) < 90.0f) && te->x != player->x && te->y != player->y) {
			vars.talkTimer = TALK_TIMER;
			if(playerNPCcollision(player->x,player->y)) {
				if(!theMap->isSolid(player->x-10,player->y-10)) {
					player->x -= 10;
					player->y -= 10; // perhaps shunt them to fix collision
				} else {
					player->x += 10;
					player->y += 10;
				}
			}
			playSound(9);
			if(vars.drunkenness < 3) {
				if(te->conversation[0] != "Questy" && te->conversation[0] != "Shoppy" && te->conversation[0] != "Gamble"
				   && te->conversation[0] != "Ending" && te->conversation[0] != "Keyshop" && te->conversation[0] != "Plyr") {
					if(vars.flags[te->flagId]) {
						vars.currentTalk = te->myName + " says: \"" + te->conversation[1] + "\"";
					}
					else {
						vars.currentTalk = te->myName + " says: \"" + te->conversation[0] + "\"";
					}
				}
				else if(te->conversation[0] == "Questy") {
					//vars.currentTalk = te->myName + " says: \"" + getNextQuest() +'\"";
					vars.currentTalk = te->myName + " intones: \"" + getNextQuest() +"\"";
				}
				else if(te->conversation[0] == "Shoppy") {
					vars.currentTalk = te->myName + " says \"Welcome to my store!\"";
					shopLoop(-1);
				}
				else if(te->conversation[0] == "Keyshop") {
					vars.currentTalk = te->myName + " says \"Buy your room-keys here!\"";
					shopLoop(11);
				}
				else if(te->conversation[0] == "Gamble") {
					vars.currentTalk = te->myName + " says: \"" + te->conversation[1] + "\"";
					gambleLoop();
				}
				else if(te->conversation[0] == "Ending") {
					//vars.currentTalk = "Calculating Endings!"; // DEBUG ONLY
					calculateEndings();
				}
				else if(te->conversation[0] == "Plyr") {
					vars.currentTalk = "Handed over control and items";
					player = te; // switch control
				}
				return;
			} else {
				string str;
				for(int i = 0; i < 30; i++) {
					str += (char)(rand() % 26) + 'a';
				}
				vars.currentTalk = te->myName + " says: \"" + str + "\"";
				//delete[] str;
				return;
			}
		}
	}
}