#include "csrpg2.h"
#include "SDL_ttf.h"

void CGame::drawTextAt(const char *text, int x, int y) {
	SDL_Colour colour = {255,255,255,255};
	SDL_Surface *temp = TTF_RenderText_Solid(font,text,colour);
	if(!temp) {
		return;
	}
	SDL_Rect rect;
	rect.x = x;
	rect.y = y;
	rect.w = temp->w;
	rect.h = temp->h;
	SDL_BlitSurface(temp,NULL,screen,&rect);
	SDL_FreeSurface(temp);
}

void CGame::drawAlphaTextAt(const char *text, int x, int y, int alpha) {
	SDL_Colour colour = {255,255,255,255};
	SDL_Surface *temp = TTF_RenderText_Solid(font,text,colour);
	if(!temp) {
		return;
	}
	SDL_SetAlpha(temp, SDL_SRCALPHA, alpha);
	SDL_Surface *temp2 = SDL_DisplayFormat(temp);
	SDL_FreeSurface(temp);
	SDL_Rect rect;
	rect.x = x;
	rect.y = y;
	rect.w = temp2->w;
	rect.h = temp2->h;
	SDL_BlitSurface(temp2,NULL,screen,&rect);
	SDL_FreeSurface(temp2);
}

void CGame::centreTextAt(const char *text, int y) {
	SDL_Colour colour = {255,255,255,255};
	SDL_Surface *temp = TTF_RenderText_Solid(font,text,colour);
	if(!temp) {
		return;
	}
	SDL_Rect rect;
	rect.x = (SCREEN_WIDTH-(temp->w))/2;
	rect.y = y;
	rect.w = temp->w;
	rect.h = temp->h;
	SDL_BlitSurface(temp,NULL,screen,&rect);
	SDL_FreeSurface(temp);
}

void CGame::centreAlphaTextAt(const char *text, int y, int alpha) {
	SDL_Colour colour = {255,255,255,255};
	SDL_Surface *temp = TTF_RenderText_Solid(font,text,colour);
	if(!temp) {
		return;
	}
	SDL_SetAlpha(temp,SDL_SRCALPHA,alpha);
	SDL_Rect rect;
	rect.x = (SCREEN_WIDTH-(temp->w))/2;
	rect.y = y;
	rect.w = temp->w;
	rect.h = temp->h;
	SDL_BlitSurface(temp,NULL,screen,&rect);
	SDL_FreeSurface(temp);
}


int CGame::returnTextHeight() {
	if(textHeight == 0) {
		SDL_Color c = {0,0,0,0};
		SDL_Surface *temp = TTF_RenderText_Solid(font,"x",c);
		int h = temp->h;
		textHeight = h;
		SDL_FreeSurface(temp);
		return h;
	}
	return textHeight;
}