#include "vars.h"
#include <fstream>
#include <string>
using namespace std;


int readNumberFromFileV(std::ifstream &TheInputFileV) {
	/*
	 Reads the next line out of the file and returns it as a
	 basic integer number
	 */
	char *line = new char[LINE_SIZE];
	TheInputFileV.getline(line,LINE_SIZE,'\n');
	return atoi(line);
}

string readStringFromFileV(std::ifstream &TheInputFileV) {
	/*
	 Reads the next line out of the file and returns it as a
	 C++/STL string
	 */
	char *line = new char[LINE_SIZE];
	TheInputFileV.getline(line,LINE_SIZE,'\n');
	string result = line;
	delete[] line;
	return result;
}

void writeStringToFileV(string enter, std::ofstream &TheOutputFileV) {
	/*
	 Write the string into the file and then end with a newline
	 */
	TheOutputFileV << enter.c_str();
	TheOutputFileV << "\n";
}

void writeNumberToFileV(int number, std::ofstream &TheOutputFileV) {
	/*
	 Write the number into the file and end with a newline
	 */
	TheOutputFileV << number;
	TheOutputFileV << "\n";
}

void MiscVars::serializeTo(char *filename) {
	std::ofstream TheOutputFileV;
	TheOutputFileV.open(filename);
	writeStringToFileV(gameName.c_str(), TheOutputFileV);
	writeNumberToFileV(menuScreen, TheOutputFileV);
	/*writeNumberToFileV((int)timer_start);
	writeNumberToFileV((int)timer_elapsed);*/
	writeNumberToFileV(frames, TheOutputFileV);
	writeNumberToFileV((int)drunkenness, TheOutputFileV);
	
	if(hasFloater) {
		writeNumberToFileV(1,TheOutputFileV);
	} else {
		writeNumberToFileV(0,TheOutputFileV); // Bugfix: Always wrote a 1, regardless of floater status.
	}
	
	// serialize flags
	for(int i = 0; i < MAX_FLAGS; i++) {
		if(flags[i]) {
			writeNumberToFileV(1, TheOutputFileV);
		} else {
			writeNumberToFileV(0, TheOutputFileV);
		}
	}
	writeStringToFileV(dir.c_str(), TheOutputFileV);
	TheOutputFileV.close();
}

int MiscVars::serializeFrom(char *filename) {
	std::ifstream TheInputFileV;
	TheInputFileV.open(filename);
	if(!TheInputFileV) {
		fprintf(stderr,"*** ERROR *** File not found: %s\n",filename);
		return -1; // file not found
	}
	gameName = readStringFromFileV(TheInputFileV);
	menuScreen = readNumberFromFileV(TheInputFileV);
	/*timer_start = (float)readNumberFromFileV();
	timer_elapsed = (float)readNumberFromFileV();
	timer_delta = timer_elapsed / 1000.0f;*/
	frames = readNumberFromFileV(TheInputFileV);
	drunkenness = (float)readNumberFromFileV(TheInputFileV);
	if(readNumberFromFileV(TheInputFileV) > 0) {
		hasFloater = true;
	} else {
		hasFloater = false;
	}
	for(int i = 0; i < MAX_FLAGS; i++) {
		if(TheInputFileV.eof()) {
			fprintf(stderr,"File too short!\n");
			TheInputFileV.close();
			return 0;
		}
		if(readNumberFromFileV(TheInputFileV) > 0) {
			flags[i] = true;
		} else {
			flags[i] = false;
		}
	}
	dir = readStringFromFileV(TheInputFileV);
	TheInputFileV.close();
	return 0;
}