#include "editor.h"
#include "item.h"
#include "player.h"

void MapEditor::loadActors(char *dir) {
	/// NEED TO CLEAR CURRENT ACTORS IN MEMORY!!!!
	char *filename = new char[60];
	bool bStillLoading = 1;
	Uint32 i = 0;
	while(bStillLoading) {
		sprintf(filename,"%s/npcdef/%i.def",dir,i);
		Actor *newActor = new Actor();
		if(newActor->serializeFrom(filename) != 0) {
			if(i == 0) {
				fprintf(stderr,"*** WARNING *** DATA DIR %s IS MISSING filename %s\n",dir,filename);
				exit(1);
			}
			delete newActor;
			bStillLoading = 0;
		} else {
			actorList.push_back(newActor);
		}
		i++;
	}
	delete[] filename;
}

void MapEditor::loadItems(char *dir) {
	char *filename = new char[60];
	bool bStillLoading = 1;
	Uint32 i = 0;
	while(bStillLoading) {
		sprintf(filename,"%s/idef/%i.def",dir,i);
		Item *newItem = new Item();
		if(newItem->serializeFrom(filename) != 0) {
			if(i == 0) {
				fprintf(stderr,"*** WARNING *** DATA DIR %s IS MISSING\n",dir);
				exit(1);                        
			}
			delete newItem;
			bStillLoading = 0;
		} else {
			itemVec.push_back(newItem);
		}
		i++;
	}
	delete[] filename;
}

void MapEditor::saveActors(char *dir) {
	char *filename = new char[60];
	int i = 0;        
	list <Actor*>::iterator ait;
	for(ait = actorList.begin(); ait != actorList.end(); ait++) {
		sprintf(filename,"%s/npcdef/%i.def",dir,i);
		Actor* ap = *ait;
		ap->serializeTo(filename);
		i++;
		//delete[] filename;
	}
	delete[] filename;
}

void MapEditor::saveItems(char *dir) {
	char *filename = new char[60];
	//printf("There are %i items in the item vector\n",(int)itemVec.size());        
	for(unsigned i = 0; i < itemVec.size(); i++) {
		sprintf(filename,"%s/idef/%i.def",dir,i);
		Item* ap = itemVec[i];
		ap->serializeTo(filename);
		//delete[] filename;
	}
	delete[] filename;
}