#include "editor.h"

void MapEditor::drawMap() {
	SDL_Rect tileRect;
	for(int r = 0; r < 20; r++) {
		for(int c = 0; c < 20; c++) {
			int cur_x = c + x;
			int cur_y = r + y;
			tileRect.x = c * 48;
			tileRect.y = r * 48;
			int tile = theMap.getTileAt(cur_x,cur_y);
			if(tile < 0) {
				fprintf(stderr,"Invalid tile: %i,%i\n",cur_x,cur_y);
				tile = 0;
			}
			SDL_BlitSurface(art.tiles[tile],NULL,screen,&tileRect);
			if(cur_x >= x1 && cur_y >= y1 && cur_y <= y2 && cur_x <= x2) {
				// Draw the multiple selection box.
				SDL_FillRect(screen,&tileRect,SDL_MapRGB(screen->format,255,0,0));
			}
		}
	}
	tileRect.y = 430;
	tileRect.x = 800 - 48;
	drawTextAt("Current tile:", 700, tileRect.y - 20);
	SDL_BlitSurface(art.tiles[curTile],NULL,screen,&tileRect);
}