#include "editor.h"

int main(int argc, char *argv[]) {
	MapEditor* editor = new MapEditor();
	editor->mainloop();
	delete editor;
	return 0;
}

MapEditor::MapEditor() {
	screen = SDL_SetVideoMode(800,600,16,SDL_HWSURFACE|SDL_DOUBLEBUF);
	art.loadAssets();													/// Make sure there's a nice symlink
	theMap.loadMap("data");											/// Start user with scratch map
	our_minimap = renderMinimap(theMap);
	bMiniMap = true;
	x = 0;
	y = 0;
	x1 = -1;
	y1 = -1;
	x2 = -1;
	y2 = -1;
	curTile = 0;
	mode = 0;
	TTF_Init();
	bJustLoaded = false;
	bPalette = false;
	scroll = 0;
	font = TTF_OpenFont("edfont.ttf",14);
	if(!font) {
		fprintf(stderr,"Could not locate font!\n");
		exit(1);
	}
}

void MapEditor::mainloop() {
	bool bIsOver = false;
	char *title = new char[40];
	while(!bIsOver) {
		drawMap();
		drawHUD();
		drawSprites();
		getInput();
		sprintf(title,"x=%i y=%i",x,y);
		SDL_WM_SetCaption(title,NULL);
		SDL_Delay(0);					// prevent 100% cpu usage
		SDL_Flip(screen);
	}
}