#ifndef _EDITOR_H_
#define _EDITOR_H_

#include "editor.h"
#include "SDL_ttf.h"
#include "../../src/Map.h"
#include "../../src/defines.h"
#include "../../src/vars.h"
#include "../../src/player.h"
#include "../../src/item.h"
#include <list>
using namespace std;

// Right-click button modes
#define SELECT_MODE 0
#define NPC_PLACE_MODE 1
#define ITEM_PLACE_MODE 2
#define NPC_KILL_MODE 3
#define ITEM_KILL_MODE 4

class MapEditor {
	public:
		void mainloop();
		MapEditor();
	private:
		Map theMap;
		int x, y;								/// For (x,y) scroll
		int x1, x2, y1, y2;						/// For "Fills"
		SDL_Surface *screen;
		ArtAssets art;
		SDL_Event event;
		TTF_Font *font;
		int curTile;
		void drawMap();
		void getInput();
		void drawHUD();
		void drawSprites();
		void drawTextAt(const char *msg, int x, int y);
		string getUserString(const char *askFor, int x, int y);
		int mode;
		void createNewNPCAt(int x, int y);
		void createNewItemAt(int x, int y);
		void killNPCAt(int x, int y);
		void killItemAt(int x, int y);
		bool collide(int ax, int ay, int aw, int ah, int bx, int by, int bw, int bh);
		SDL_Surface *renderMinimap(Map &theMap);
		void drawScrollbox(int sx, int sy); // Draw a box to show where you are scrolling
		void drawTilePalette();
		void reloadMinimap();
		SDL_Surface *our_minimap;
		bool bMiniMap;
		bool bPalette;
		int scroll;
		
		// Save and load
		void loadActors(char *dir);
		void saveActors(char *dir);
		void loadItems(char *dir);
		void saveItems(char *dir);
		
		// Lists & Vectors
		list <Actor*> actorList;
		vector <Item*> itemVec;
		
		// boolean flags
		bool bJustLoaded;
};

#endif