#include "editor.h"

void MapEditor::drawHUD() {
	if(bMiniMap && our_minimap) {
		SDL_Rect rect = {0,0,0,0};
		SDL_BlitSurface(our_minimap,NULL,screen,&rect);
	}
	drawScrollbox(x,y);
	if(mode == SELECT_MODE) {
		drawTextAt("Right Click: Select multiple tiles",0,580);
	}
	else if(mode == NPC_PLACE_MODE) {
		drawTextAt("Right Click: Place NPC",0,580);
	}
	else if(mode == ITEM_PLACE_MODE) {
		drawTextAt("Right Click: Place Item",0,580);
	}
	else if(mode == NPC_KILL_MODE) {
		drawTextAt("Right Click: Kill NPC",0,580);
	}
	else if(mode == ITEM_KILL_MODE) {
		drawTextAt("Right click: Kill item",0,580);
	}
	
	if(bPalette) {
		drawTilePalette();
	}
}

void MapEditor::drawTextAt(const char *msg, int x, int y) {
	SDL_Colour colour = {255,255,255,255};
	colour.g = 0;
	colour.b = 0; // ooh, red text
	SDL_Surface *temp = TTF_RenderText_Solid(font,msg,colour);
	if(!temp) {
		//printf("Uh oh!\n");
		return;
	}
	SDL_Rect rect;
	rect.x = x;
	rect.y = y;
	rect.w = temp->w;
	rect.h = temp->h;
	SDL_BlitSurface(temp,NULL,screen,&rect);
	SDL_FreeSurface(temp);
}