#include "editor.h"

void MapEditor::drawSprites() {
	float wx = (x * 48);
	float wy = (y * 48); // in world coords.
	SDL_Rect drawRect;
	drawRect.w = 48;
	drawRect.h = 48;
	list <Actor*>::iterator ait;
	for(ait = actorList.begin(); ait != actorList.end(); ait++) {
		Actor *te = *ait;
		if(te->x > wx && te->y > wy && te->x < (wx + 800) && te->y < (wy + 600)) {
			// On screen!
			drawRect.x = (Sint16)(te->x - wx);
			drawRect.y = (Sint16)(te->y - wy); // offset from edge of screen
			if(te->sprite >= 0 && te->sprite < MAX_CHARS && te->direction >= 0 && te->direction <= 3) {
				SDL_BlitSurface(art.sprites[te->sprite][te->direction][0],NULL,screen,&drawRect);
			} else {
				SDL_BlitSurface(art.icons[ICON_MISSED],NULL,screen,&drawRect);
			}
		}
	}
	for(unsigned int i = 0; i < itemVec.size(); i++) {
		if(itemVec[i]->x >= wx && itemVec[i]->y >= wy &&
		   itemVec[i]->x < (wx + 800) &&
		   itemVec[i]->y < (wy+600) &&
		   itemVec[i]->type != ITEM_DEAD) {
			// Can be drawn
			drawRect.x = (Sint16)(itemVec[i]->x - wx);
			drawRect.y = (Sint16)(itemVec[i]->y - wy);
			if(itemVec[i]->icon >= 0 && itemVec[i]->icon < art.items.size()) {
				if(itemVec[i]->owner != 0) {
					// Draw a fireball under it. It's NOT YOURS
					SDL_BlitSurface(art.icons[ICON_FIREBALL],NULL,screen,&drawRect);
				}
				SDL_BlitSurface(art.items[itemVec[i]->icon],NULL,screen,&drawRect);
			} else {
				SDL_BlitSurface(art.icons[ICON_MISSED],NULL,screen,&drawRect);
			}
		}
	}
}