#include "editor.h"
#include "player.h"

void MapEditor::createNewNPCAt(int x, int y) {
	Actor* newActor = new Actor();
	newActor->x = x;
	newActor->y = y;
	newActor->myName = getUserString("Name:",10,0);
	newActor->conversation[0] = getUserString("First convo string:",10,40);
	newActor->conversation[1] = getUserString("Second convo string:",10,80);
	newActor->sprite = atoi(getUserString("Sprite to use:",10,120).c_str());
	newActor->direction = atoi(getUserString("Direction (0-3):",10,160).c_str());
	newActor->flagId = atoi(getUserString("Response flag ID:",10,200).c_str());
	newActor->stats.hp = atoi(getUserString("HP:",10,240).c_str());
	newActor->stats.hp_max = atoi(getUserString("HP MAX:",10,280).c_str());
	newActor->stats.mp = atoi(getUserString("MP:",10,320).c_str());
	newActor->stats.mp_max = atoi(getUserString("MP MAX:",10,360).c_str());
	newActor->stats.xp = atoi(getUserString("Experience:",10,400).c_str());
	newActor->stats.strength = atoi(getUserString("Strength:",10,440).c_str());
	newActor->stats.dexterity = atoi(getUserString("Dexterity:",10,480).c_str());
	newActor->stats.intelligence = atoi(getUserString("Intelligence:",10,520).c_str());
	SDL_FillRect(screen,NULL,SDL_MapRGB(screen->format,0,0,100));
	// BOOLEANS
	if(atoi(getUserString("Boolean, is Hostile:",10,0).c_str()) > 0) {
		newActor->bIsHostile = true;
	} else {
		newActor->bIsHostile = false;
	}
	if(atoi(getUserString("Boolean, is wandering:",10,40).c_str()) > 0) {
		newActor->bIsWanderer = true;
	} else {
		newActor->bIsWanderer = false;
	}
	actorList.push_back(newActor);
}

void MapEditor::createNewItemAt(int x, int y) {
	Item* newItem = new Item();
	newItem->x = x;
	newItem->y = y;
	newItem->itemName = getUserString("Name:",10,0);
	newItem->shortName = getUserString("Short name:",10,40);
	newItem->itemDescript = getUserString("Description:",10,80);
	newItem->type = atoi(getUserString("Type (check docs for list):",10,120).c_str());
	newItem->maxEffect = atoi(getUserString("Maximum Effect:",10,160).c_str());
	newItem->price = atoi(getUserString("Price:",10,200).c_str());
	newItem->owner = atoi(getUserString("Owner (check docs for list):",10,240).c_str());
	newItem->icon = atoi(getUserString("Icon:",10,280).c_str());
	if(newItem->type == ITEM_BOW) {
		newItem->range = atoi(getUserString("This is a ranged weapon (gun or bow). Range in tiles?",10,320).c_str());
	}
	itemVec.push_back(newItem);
}

void MapEditor::killItemAt(int x, int y) {
	for(unsigned int i = 0; i < itemVec.size(); i++) {
		if(itemVec[i]->type != ITEM_DEAD) {
			if(collide(x, y, 2, 2, (int)itemVec[i]->x, (int)itemVec[i]->y, 48, 48)) {
				itemVec[i]->type = ITEM_DEAD;
				return;
			}
		}
	}
}

void MapEditor::killNPCAt(int x, int y) {
	list <Actor*>::iterator ait;
	for(ait = actorList.begin(); ait != actorList.end(); ait++) {
		Actor *te = *ait;
		if(collide(x,y,2,2,(int)te->x,(int)te->y,48,48)) {
			actorList.remove(te);
			delete te;
			ait = actorList.end();
			return;
		}
	}
}

bool MapEditor::collide(int ax, int ay, int aw, int ah, int bx, int by, int bw, int bh) {
	if((ay+ah) < by) { return false; }
	if(ay > (by + bh)) { return false; }
	if((ax+aw) < bx) { return false; }
	if(ax > (bx + bw)) { return false; }
	return true;
}