#include "csrpg2.h"

void CGame::drawHud() {
	/*
		Draw the hud
	*/
	if(vars.talkTimer > 0) {
		/*
			Draw the "talk messages". This is where you would go to change, say, the colour of messages.
		*/
		int percentage = (int)((vars.talkTimer/TALK_TIMER)*255);
		//SDL_Color fader = {percentage,percentage,percentage,0};
		/*SDL_Surface *temp = TTF_RenderText_Solid(font,vars.currentTalk.c_str(),fader);
		SDL_SetAlpha(temp, SDL_SRCALPHA, percentage);
		SDL_Rect rect = {0,0,0,0};
		rect.x = 10;
		rect.y = 600 - returnTextHeight() - 2;
		rect.w = temp->w;
		rect.h = temp->h;
		SDL_FillRect(screen,&rect,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));*/
		SDL_Rect rect;
		// Should NOT do this.
		SDL_Surface *textBox = SDL_CreateRGBSurface(0, SCREEN_WIDTH, (returnTextHeight() + 2), 32, 0,0,0,0);
		SDL_FillRect(textBox,NULL,SDL_MapRGB(screen->format,GUI_COLOR_RED,GUI_COLOR_GREEN,GUI_COLOR_BLUE));
		rect.x = 0;
		rect.y = 600 - returnTextHeight() - 2;
		if(vars.bNoAlpha) {
			// Slow-ass PC
			SDL_BlitSurface(textBox, NULL, screen, &rect);
			SDL_FreeSurface(textBox);
			centreTextAt(vars.currentTalk.c_str(), (600-returnTextHeight()));
		} else {
			// Quick and friendly PC
			SDL_SetAlpha(textBox,SDL_SRCALPHA,percentage);
			SDL_BlitSurface(textBox, NULL, screen, &rect);
			SDL_FreeSurface(textBox);
			centreAlphaTextAt(vars.currentTalk.c_str(), (600-returnTextHeight()), percentage);
		}
		/*SDL_BlitSurface(temp,NULL,screen,&rect);
		SDL_FreeSurface(temp);*/
		vars.talkTimer -= vars.timer_elapsed;
	}
	char *status = new char[512];
	// DRAW HEART
	SDL_Rect hrect;
	hrect.x = 0;
	hrect.y = 0;
	hrect.w = 48;
	hrect.h = 48;
	SDL_BlitSurface(art.icons[ICON_HEARTEMPTY],NULL,screen,&hrect);
	hrect.h = (int)(((float)player->stats.hp / player->stats.hp_max)*48);
	hrect.y += (48 - hrect.h);
	SDL_BlitSurface(art.icons[ICON_HEARTFULL],&hrect,screen,&hrect);
	// Draw text
	if(vars.debugMode) {
		// If in debugger mode, display some extra information at the top of the screen
		// for optimization reasons
		sprintf(status,"hp %i/%i fps %i max_fps %i min_fps %i",player->stats.hp,player->stats.hp_max,vars.fps,vars.fps_max,vars.fps_min);
		char *stats2 = new char[512];
		sprintf(stats2,"x: %f y: %f",player->x,player->y);
		drawTextAt(stats2,10,10+returnTextHeight());
		delete[] stats2; // Found it, this was a memory leak.
	} else {
		// Otherwise, just put the same crap up on the screen and amuse the little fuckers
		sprintf(status," Health: %i/%i",player->stats.hp,player->stats.hp_max);
		char *status2 = new char[60];
		sprintf(status2," Mana: %i/%i",player->stats.mp,player->stats.mp_max);
		drawTextAt(status2,10,10+returnTextHeight());
		sprintf(status2," $%i",player->stats.money);
		drawTextAt(status2,10,10+returnTextHeight()*2);
		delete[] status2;
	}
	drawTextAt(status,10,10);
	delete[] status;
}

void CGame::keyHelp() {
	/*
		This function is probably unnecessary, but it is helpful to tell people what
		to do.
	*/
	bool bDoneHere = false;
	while(!bDoneHere) {
		centreTextAt("***Keyboard***",100-returnTextHeight());
		centreTextAt("Space, G: Get items",100);
		centreTextAt("R: Find rest",100+returnTextHeight());
		centreTextAt("Return: Talk",100+(returnTextHeight()*2));
		centreTextAt("ESC: Inventory",100+(returnTextHeight()*3));
		centreTextAt("F1: Quick Save",100+(returnTextHeight()*4));
		centreTextAt("F2: Quit to menu",100+(returnTextHeight()*5));
		centreTextAt("F3: Screenshot",100+(returnTextHeight()*6));
		centreTextAt("H: This screen",100+(returnTextHeight()*7));
		centreTextAt("Press any key to continue",100+(returnTextHeight()*8));
		while(SDL_PollEvent(&event)) {
			if(event.type == SDL_QUIT) {
				bDoneHere = true;
			}
			else if(event.type == SDL_KEYDOWN) {
				bDoneHere = true;
			}
		}
		SDL_Flip(screen);
		SDL_Delay(0);
	}
	// Reset the delta timer so the player can't walk through walls by exploiting the fact
	// that it hasn't been updated for the frames that the help box was on screen.
	vars.timer_delta = 0;
	vars.timer_start = SDL_GetTicks();
	vars.timer_elapsed = 0;
}
